/**
 * $RCSfile: JCPKeyPane.java,v $
 * version $Revision: 1.1 $
 * created 07.06.2008 11:20:03 by kunina
 * last modified $Date: 2009/03/24 06:32:44 $ by $Author: kunina $
 * (C)  - 2004-2008.
 *
 *  ,    , 
 *   .     
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package Applet_samples.AppletNew;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Enumeration;

/**
 *  .
 *
 * @author Copyright 2004-2008 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class JCPKeyPane extends JFrame {

private JPanel page;
private JButton okButton;
private JComboBox keyBox;
private JPanel stores;
private ButtonGroup group;
private Component root;
private Image icon;
private JTextField textF;
private GridBagConstraints gbc;

/**
 * 
 *
 * @param tit 
 * @param ico 
 * @param location   
 * @param isResizable   
 * @param text       (/)
 */
public JCPKeyPane(String tit, Image ico, Component location,
                  boolean isResizable, JTextField text) {
    setupUI();
    icon = ico;
    root = location;
    textF = text;
    keyBox.setPreferredSize(
            new Dimension(150, keyBox.getPreferredSize().height));
    keyBox.setMaximumSize(keyBox.getPreferredSize());
    rButtonPanel("Stores", Processor.getStores(), stores);
    okButton.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            onOkButton();
        }
    });
    getContentPane().add(getRootComponent());
    setTitle(tit);
    setIconImage(ico);
    setLocationRelativeTo(location);
    setResizable(isResizable);
}

/**
 *  
 */
private void onOkButton() {
    if (keyBox.getSelectedItem() != null) {
        Processor.setKeyAlias(keyBox.getSelectedItem().toString());
        dispose();
        final PassPane pp = new PassPane("Password", icon, root, false, textF);
        pp.pack();
        pp.show();
    } else {
        JOptionPane.showMessageDialog(page, new String[]{
                "No key is selected"
        }, "Error", 0);
    }
}

/**
 *   -
 *
 * @param titl 
 * @param options   
 * @param panel   
 */
protected void rButtonPanel(String titl, String[] options, JPanel panel) {
    panel.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEtchedBorder(), titl));
    panel.setLayout(new BoxLayout(panel, 1));
    group = new ButtonGroup();
    final ActionListener listener = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            viewKeys();
        }
    };
    for (int i = 0; i < options.length; i++) {
        final JRadioButton button = new JRadioButton(options[i]);
        button.setActionCommand(options[i]);
        panel.add(button);
        group.add(button);
        button.setSelected(i == 0);
        button.addActionListener(listener);
    }
}

/**
 *  
 */
private void viewKeys() {
    keyBox.removeAllItems();
    final String storeName = group.getSelection().getActionCommand();
    Processor.setKeyStoreName(storeName);
    final Enumeration aliases = Processor.getAliases(storeName);
    while (aliases.hasMoreElements()) {
        keyBox.addItem(aliases.nextElement());
    }
}

/**
 *    
 *
 * @return 
 */
protected JComponent getRootComponent() {
    return page;
}

/**
 *  
 */
private void setupUI() {
    page = new JPanel();
    page.setLayout(new GridBagLayout());
    keyBox = new JComboBox();
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 1;
    gbc.fill = 2;
    gbc.insets = new Insets(5, 5, 5, 5);
    page.add(keyBox, gbc);
    stores = new JPanel();
    stores.setLayout(new GridBagLayout());
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.fill = 1;
    gbc.insets = new Insets(5, 5, 0, 5);
    page.add(stores, gbc);
    okButton = new JButton();
    okButton.setText("Ok");
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 2;
    gbc.fill = 2;
    gbc.insets = new Insets(0, 5, 0, 5);
    page.add(okButton, gbc);
}
}