/**
 * $RCSfile: Processor.java,v $
 * version $Revision: 1.1 $
 * created 07.06.2008 11:32:39 by kunina
 * last modified $Date: 2009/03/24 06:32:44 $ by $Author: kunina $
 * (C)  - 2004-2008.
 *
 *  ,    , 
 *   .      
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package Applet_samples.AppletNew;

import ru.CryptoPro.JCP.KeyStore.KeyStoreConfig;
import ru.CryptoPro.JCP.tools.Array;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.KeyAgreement;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.security.*;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.security.spec.AlgorithmParameterSpec;
import java.util.Enumeration;
import java.util.List;
import java.util.Vector;

/**
 *     .
 *
 * @author Copyright 2004-2008 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class Processor {
/**
 * 
 */
private static KeyStore store;
/**
 *   (HDImageStore, FloppyStore  ..)
 */
private static String storeName;
/**
 * 
 */
private static Key key;
/**
 *  
 */
private static String alias;
/**
 *   
 */
private static char[] keyPass;
/**
 *   /
 */
private static File file;
/**
 *   
 */
private static Certificate cert;

 /**/
public Processor() {
}

/**
 *    
 *
 * @return true/false
 */
protected static boolean checkJCP() {
    boolean ret = false;
    final Provider[] provs = Security.getProviders();
    for (int i = 0; i < provs.length; i++) {
        if ("JCP".equals(provs[i].getName())) {
            ret = true;
            break;
        }
    }
    return ret;
}

/**
 *    
 *
 * @return true/false
 */
protected static boolean checkJCPwork() {
    boolean ret;
    try {
        Signature.getInstance("GOST3411withGOST3410EL");
        ret = true;
    } catch (NoSuchAlgorithmException e) {
        ret = false;
    }
    return ret;
}

/**
 *   
 *
 * @param keyStoreName 
 */
protected static void setKeyStoreName(String keyStoreName) {
    storeName = keyStoreName;
}

/**
 *   
 *
 * @return 
 */
protected static String getKeyStoreName() {
    return storeName;
}

/**
 *   
 *
 * @param keyAlias  
 */
protected static void setKeyAlias(String keyAlias) {
    alias = keyAlias;
}

/**
 *   
 *
 * @return  
 */
protected static String getKeyAlias() {
    return alias;
}

/**
 *    
 *
 * @param password   
 */
protected static void setKeyPassword(char[] password) {
    keyPass = password;
}

/**
 *     JCP.
 *
 * @return  
 */
protected static String[] getStores() {
    final List strs = KeyStoreConfig.getNames();
    final String[] stores = new String[strs.size()];
    for (int i = 0; i < strs.size(); i++) {
        stores[i] = (String) strs.get(i);
    }
    return stores;
}

/**
 *       
 *
 * @param storeNam  
 * @return  
 */
protected static Enumeration getAliases(String storeNam) {
    Enumeration aliases = null;
    try {
        final KeyStore ks = KeyStore.getInstance(storeNam);
        store = ks;
        ks.load(null, null);
        aliases = ks.aliases();
    } catch (KeyStoreException e) {
        e.printStackTrace();
    } catch (NoSuchAlgorithmException e) {
        e.printStackTrace();
    } catch (IOException e) {
        e.printStackTrace();
    } catch (CertificateException e) {
        e.printStackTrace();
    }
    return aliases;
}

/**
 *  
 *
 * @return true/false
 */
protected static boolean readKey() {
    boolean ret = false;
    try {
        key = store.getKey(alias, keyPass);
        ret = true;
    } catch (NoSuchAlgorithmException e) {
        e.printStackTrace();
    } catch (UnrecoverableKeyException e) {
        e.printStackTrace();
    } catch (KeyStoreException e) {
        e.printStackTrace();
    }
    return ret;
}

/**
 *     
 *
 * @param pfile 
 */
protected static void setFile(File pfile) {
    file = pfile;
}

/**
 *   
 *
 * @return true/false
 */
protected static boolean isSetFile() {
    return file != null;
}

/**
 *  
 *
 * @param certificate 
 */
protected static void setCert(Certificate certificate) {
    cert = certificate;
}

/**
 *   
 *
 * @return true/false
 */
protected static boolean isSetCert() {
    return cert != null;
}

/**
 *    
 *
 * @param certFile  
 * @return 
 */
protected static List genCertFromFile(File certFile) {
    final List ret = new Vector(2);
    String err = null;
    Certificate certif = null;
    try {
        final CertificateFactory cf = CertificateFactory.getInstance("X509");
        if (certFile != null)
            certif = cf.generateCertificate(new FileInputStream(certFile));
    } catch (CertificateException e) {
        err = "Can't generate certificate";
    } catch (FileNotFoundException e) {
        err = e.toString();
    }
    ret.add(0, err);
    ret.add(1, certif);
    return ret;
}

/**
 * 
 *
 * @return 
 */
protected static List sign() {
    final List ret = new Vector(2);
    String err = null;
    byte[] signature = null;
    if (file != null)
        try {
            final Signature sign =
                    Signature.getInstance("GOST3411withGOST3410EL");
            sign.initSign((PrivateKey) key);
            sign.update(Array.readFile(file));
            signature = sign.sign();
        } catch (NoSuchAlgorithmException e) {
            err = e.toString();
        } catch (SignatureException e) {
            err = e.toString();
        } catch (InvalidKeyException e) {
            err = e.toString();
        } catch (IOException e) {
            err = e.toString();
        }
    ret.add(0, err);
    ret.add(1, signature);
    return ret;
}

/**
 *  
 *
 * @param fileWithSign   
 * @return /
 */
public static List signVerify(File fileWithSign) {
    final List ret = new Vector(2);
    String err = null;
    boolean ver = false;
    if (file != null && fileWithSign != null)
        try {
            final Signature sig =
                    Signature.getInstance("GOST3411withGOST3410EL");
            sig.initVerify(cert.getPublicKey());
            sig.update(Array.readFile(file));
            ver = sig.verify(Array.readFile(fileWithSign));
        } catch (NoSuchAlgorithmException e) {
            err = e.toString();
        } catch (InvalidKeyException e) {
            err = e.toString();
        } catch (IOException e) {
            err = e.toString();
        } catch (SignatureException e) {
            err = e.toString();
        }
    ret.add(0, err);
    ret.add(1, String.valueOf(ver));
    return ret;
}

/**
 * 
 *
 * @param mode 
 * @param isENCRYPT encrypt/decrypt
 * @return encrypted/decrypted text
 */
public static List crypt(String mode, boolean isENCRYPT) {
    final List ret = new Vector(2);
    String err = null;
    final int mod;
    byte[] crypted = null;
    if (isENCRYPT) mod = Cipher.ENCRYPT_MODE;
    else mod = Cipher.DECRYPT_MODE;
    try {
        final KeyAgreement keyAgree = KeyAgreement.getInstance("GOST3410DH");
        //todo iv
        final AlgorithmParameterSpec iv =
                new IvParameterSpec(new byte[]{1, 2, 3, 4, 5, 6, 7, 8});
        keyAgree.init(key, iv, null);//iv
        keyAgree.doPhase(cert.getPublicKey(), true);
        final SecretKey secret = keyAgree.generateSecret("GOST28147");
        final Cipher cipher = Cipher.getInstance(mode);
        cipher.init(mod, secret, iv);//iv
        crypted = cipher.doFinal(Array.readFile(file));
    } catch (NoSuchAlgorithmException e) {
        err = e.toString();
    } catch (NoSuchPaddingException e) {
        err = e.toString();
    } catch (InvalidKeyException e) {
        err = e.toString();
    } catch (BadPaddingException e) {
        err = e.toString();
    } catch (IOException e) {
        err = e.toString();
    } catch (IllegalBlockSizeException e) {
        err = e.toString();
    } catch (InvalidAlgorithmParameterException e) {
        err = e.toString();
    }
    ret.add(0, err);
    ret.add(1, crypted);
    return ret;
}

/**
 * clean
 */
protected static void cleanAll() {
    store = null;
    storeName = null;
    key = null;
    alias = null;
    keyPass = null;
    file = null;
    cert = null;
}
}
