/**
 * $RCSfile: CMSDecrypt.java,v $
 * version $Revision: 1.5 $
 * created 28.05.2008 10:26:51 by kunina
 * last modified $Date: 2009/04/22 12:52:44 $ by $Author: kunina $
 * (C)  - 2004-2008.
 *
 *  ,    , 
 *   .     
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package CMS_samples;

import com.objsys.asn1j.runtime.Asn1BerDecodeBuffer;
import com.objsys.asn1j.runtime.Asn1BerEncodeBuffer;
import ru.CryptoPro.Crypto.spec.GostCipherSpec;
import ru.CryptoPro.JCP.ASN.CryptographicMessageSyntax.ContentInfo;
import ru.CryptoPro.JCP.ASN.CryptographicMessageSyntax.EnvelopedData;
import ru.CryptoPro.JCP.ASN.CryptographicMessageSyntax.KeyTransRecipientInfo;
import ru.CryptoPro.JCP.ASN.CryptographicMessageSyntax.RecipientInfo;
import ru.CryptoPro.JCP.ASN.Gost28147_89_EncryptionSyntax.Gost28147_89_Parameters;
import ru.CryptoPro.JCP.ASN.GostR3410_EncryptionSyntax.GostR3410_KeyTransport;
import ru.CryptoPro.JCP.params.OID;
import ru.CryptoPro.JCP.tools.Array;

import javax.crypto.Cipher;
import javax.crypto.KeyAgreement;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import java.security.KeyFactory;
import java.security.KeyStore;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.spec.X509EncodedKeySpec;

/**
 * Decrypt message.
 *
 * @author Copyright 2004-2009 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class CMSDecrypt {
//private static final String CMS_FILE_PATH = "envCMS.txt";
private static final String CMS_FILE_PATH = CMSSignAndEncrypt.CMS_FILE_PATH;
private static final String CIPHER_MODE = CMSSignAndEncrypt.CIPHER_MODE;

public static void main(String[] args) throws Exception {
    // cms-  
    final byte[] buffer = Array.readFile(CMS_FILE_PATH);
    // CMS-
    Asn1BerDecodeBuffer dbuf = new Asn1BerDecodeBuffer(buffer);
    final ContentInfo all = new ContentInfo();
    all.decode(dbuf);
    dbuf.reset();
    final EnvelopedData cms = (EnvelopedData) all.content;

    KeyTransRecipientInfo keytrans = new KeyTransRecipientInfo();
    if (cms.recipientInfos.elements[0].getChoiceID() == RecipientInfo._KTRI)
        keytrans =
                (KeyTransRecipientInfo) (cms.recipientInfos.elements[0].getElement());
    final Asn1BerEncodeBuffer ebuf = new Asn1BerEncodeBuffer();
    dbuf = new Asn1BerDecodeBuffer(keytrans.encryptedKey.value);
    final GostR3410_KeyTransport encrKey = new GostR3410_KeyTransport();
    encrKey.decode(dbuf);
    dbuf.reset();
    encrKey.sessionEncryptedKey.encode(ebuf);
    final byte[] wrapKey = ebuf.getMsgCopy();
    ebuf.reset();
    encrKey.transportParameters.ephemeralPublicKey.encode(ebuf);
    final byte[] encodedPub = ebuf.getMsgCopy();
    ebuf.reset();
    final byte[] sv = encrKey.transportParameters.ukm.value;
    final Gost28147_89_Parameters params =
            (Gost28147_89_Parameters) cms.encryptedContentInfo.contentEncryptionAlgorithm.parameters;
    final byte[] iv = params.iv.value;
    final OID cipherOID = new OID(params.encryptionParamSet.value);
    final byte[] text = cms.encryptedContentInfo.encryptedContent.value;

    // 
    final KeyStore hdImageStore = KeyStore.getInstance(CMStools.STORE_TYPE);
    hdImageStore.load(null, null);
    // -  
    final PrivateKey responderKey =
            (PrivateKey) hdImageStore.getKey(CMStools.RECIP_KEY_NAME,
                    CMStools.RECIP_KEY_PASSWORD);

    // -    cms
    final X509EncodedKeySpec pspec = new X509EncodedKeySpec(encodedPub);
    final KeyFactory kf = KeyFactory.getInstance(CMStools.KEY_ALG_NAME);
    final PublicKey senderPublic = kf.generatePublic(pspec);

    //    
    final KeyAgreement responderKeyAgree =
            KeyAgreement.getInstance(CMStools.KEY_ALG_NAME);
    responderKeyAgree.init(responderKey, new IvParameterSpec(sv), null);
    responderKeyAgree.doPhase(senderPublic, true);
    final SecretKey responderSecret = responderKeyAgree
            .generateSecret(CMStools.SEC_KEY_ALG_NAME);

    //   .
    final Cipher cipher = Cipher.getInstance(CIPHER_MODE);
    cipher.init(Cipher.UNWRAP_MODE, responderSecret, (SecureRandom) null);
    final SecretKey simmKey = (SecretKey) cipher
            .unwrap(wrapKey, null, Cipher.SECRET_KEY);

    //     .
    final GostCipherSpec spec = new GostCipherSpec(iv, cipherOID);
    cipher.init(Cipher.DECRYPT_MODE, simmKey, spec, null);
    final byte[] result = cipher.doFinal(text, 0, text.length);
    // if result = signedData ($CMS_FILE)
    CMSVerify.CMSVerify(result, null, null);
}
}
