/**
 * $RCSfile: CSignDataUse.java,v $
 * version $Revision: 1.3 $
 * created 08.07.2008 17:06:43 by kunina
 * last modified $Date: 2009/04/22 12:52:44 $ by $Author: kunina $
 * (C)  - 2004-2008.
 *
 *  ,    , 
 *   .      
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package CMS_samples;

import ru.CryptoPro.JCP.tools.Array;
import ru.CryptoPro.JCP.tools.Decoder;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.nio.CharBuffer;
import java.nio.charset.Charset;
import java.nio.charset.CharsetEncoder;

/**
 *       CSignData.js.
 * <p/>
 *    (      
 * java     UTF-16LE ).
 * <p/>
 *    UTF-16LE     
 *
 * @author Copyright 2004-2009 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class CSignDataUse {
 /**/
public CSignDataUse() {
}

/**
 *     
 */
private static final String DIR_NAME = "CsignDataSample";
private static final String DIR_PATH =
        CMStools.TEST_PATH + CMStools.SEPAR + DIR_NAME;

/**
 *  cms 
 */
private static final String CMS_FILE = "cap.cms";
private static final String CMS_FILE_PATH =
        DIR_PATH + CMStools.SEPAR + CMS_FILE;

/**
 *  
 */
private static final String DATA_FILE = "text.txt";
private static final String DATA_FILE_PATH =
        DIR_PATH + CMStools.SEPAR + DATA_FILE;

/**
 * @param args /
 * @throws Exception /
 */
public static void main(String[] args) throws Exception {
    //  
    new File(DIR_PATH).mkdir();

    //   
    Array.writeFile(DATA_FILE_PATH, "text".getBytes());

    //    CSignData.js (  )
    //cscript CSignData.js sign $DIR_PATH\text.txt $DIR_PATH\cap.cms

    //
    if (new File(CMS_FILE_PATH).exists()) {
        // 
        verify();
    }
}

/**
 *  ,    CSignData.js
 *
 * @throws Exception /
 */
public static void verify()
        throws Exception {
    // cms 
    final byte[] cmsBase = Array.readFile(CMS_FILE_PATH);

    //  base64  der
    final Decoder decoder = new Decoder();
    final byte[] cmsDer =
            decoder.decodeBuffer(new ByteArrayInputStream(cmsBase));

    //   UTF-16LE
    final byte[] data = Array.readFile(DATA_FILE_PATH);
    final Charset charset = Charset.forName("UTF-16LE");
    final CharsetEncoder encoder = charset.newEncoder();
    final byte[] encData =
            encoder.encode(CharBuffer.wrap(new String(data))).array();

    // 
    CMSVerify.CMSVerify(cmsDer, null, encData);
}
}
