/**
 * $RCSfile: Certs.java,v $
 * version $Revision: 1.8 $
 * created 28.06.2007 14:49:57 by kunina
 * last modified $Date: 2009/09/25 13:12:13 $ by $Author: kunina $
 * (C)  - 2004-2007.
 *
 *  ,    , 
 *   .      
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package ComLine;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.KeyStore;
import java.security.PrivateKey;
import java.security.cert.Certificate;
import java.security.cert.CertificateFactory;
import java.util.Properties;
import java.util.logging.Logger;

/**
 *   
 *
 * @author Copyright 2004-2007 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class Certs {
/**
 * logger
 */
private static Logger log = Logger.getLogger("LOGGER");

/**
 * forbidden
 */
private Certs() {
}

/**
 * Certs -alias name_of_key [-storetype HDImageStore] [-storepath null]
 * [-storepass null] [-keypass password] -certs C:/my.cer,C:/*.cer,...,C:/root.cer
 * <p/>
 * <DL> <DT><b> -alias </b>  <DD>  </DD> <DT><b> -keypass </b>
 * <DD>   <DD>(  null)</DD> <DT><b> -storetype </b>
 * <DD>   HDImageStore ( ), FloppyStore
 * (), OCFStore  J6CFStore () <DD>( 
 * HDImageStore)</DD> <DT><b>-storepath </b> <DD>   
 *  <DD>(  null)</DD> <DT><b> -storepass </b> <DD>
 *     <DD>(  null)</DD> <DT><b>
 * -erts</b> <DD>  </DD></DT> </DL>
 *
 * @param args   
 */
public static void main(String[] args) {
    if (ComLine.getFunc(ComLine.hllp, args)) log.info(ComLine.CertsHelpHD);
    else
        try {
            //      
            //      
            final Properties ArgList = new Properties();
            //  
            ArgList.setProperty(ComLine.ALIAS,
                    ComLine.getValue(ComLine.ALIAS, args, null));
            //   
            ArgList.setProperty(ComLine.keypass,
                    ComLine.getValue(ComLine.keypass, args, "null"));
            //  
            ArgList.setProperty(ComLine.storetype,
                    ComLine.getValue(ComLine.storetype, args,
                            ComLine.HDImageStore));
            //    
            ArgList.setProperty(ComLine.storepath,
                    ComLine.getValue(ComLine.storepath, args, "null"));
            //    
            ArgList.setProperty(ComLine.storepass,
                    ComLine.getValue(ComLine.storepass, args, "null"));
            //  
            ArgList.setProperty(ComLine.certs,
                    ComLine.getValue(ComLine.certs, args, null));

            //  .
            //       HDImageStore.
            final String ks;
            ks = ArgList.getProperty(ComLine.storetype);
            if (ks.equalsIgnoreCase(ComLine.HDImageStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.FloppyStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.OCFStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.J6CFStore)) {
            } else {
                ArgList.setProperty(ComLine.storetype, ComLine.HDImageStore);
                log.info("Incorrect keystore type: " + ks +
                        ". Value by default is appropriated: " + ComLine
                        .HDImageStore);
            }

            //       
            Certs(
                    ArgList.getProperty(ComLine.ALIAS),
                    ArgList.getProperty(ComLine.keypass),
                    ArgList.getProperty(ComLine.storetype),
                    ArgList.getProperty(ComLine.storepass),
                    ArgList.getProperty(ComLine.storepath),
                    ArgList.getProperty(ComLine.certs));

        } catch (NullPointerException e) {
            //System.out.println(e.toString());
            log.info(ComLine.CertsHelpHD);
        } catch (ArrayIndexOutOfBoundsException ae) {
            log
                    .info("\nWrong input in command line (" + ComLine.certs +
                            ")\n\n" + ComLine.CertsHelpHD);
        } catch (Exception e1) {
            final String sss = "java.lang.Exception:";
            log.info("\n" +
                    e1.toString()
                            .substring(sss.length(), e1.toString().length()) +
                    "\n" + ComLine.CertsHelpHD);
        }

}

/**
 * @param alias  
 * @param keypass   
 * @param keystoreName   
 * @param keystorePass     
 * @param keystorePath     
 * @param certs   
 * @throws Exception ...
 */
private static void Certs(String alias,
                          String keypass,
                          String keystoreName,
                          String keystorePass,
                          String keystorePath,
                          String certs) throws Exception {

    // 
    final String[] certnames = certs.split(",");
    final CertificateFactory cf = CertificateFactory.getInstance("X509");
    final Certificate[] Certificates = new Certificate[certnames.length];
    for (int i = 0; i < certnames.length; i++) {
        Certificates[i] =
                cf.generateCertificate(new FileInputStream(certnames[i]));
    }

    //      
    final KeyStore ks = KeyStore.getInstance(keystoreName);
    char[] KeyStorePass = null;
    if (!"null".equalsIgnoreCase(keystorePass)) {
        KeyStorePass = keystorePass.toCharArray();
    }
    InputStream is = null;
    if (!"null".equalsIgnoreCase(keystorePath)) {
        is = new FileInputStream(keystorePath);
    }
    ks.load(is, KeyStorePass);
    final PrivateKey key;
    char[] Keypass = null;
    if (!"null".equalsIgnoreCase(keypass)) {
        Keypass = keypass.toCharArray();
    }
    key = (PrivateKey) ks.getKey(alias, Keypass);
    ks.setKeyEntry(alias, key, Keypass, Certificates);
    OutputStream os = null;
    if (!"null".equalsIgnoreCase(keystorePath)) {
        os = new FileOutputStream(keystorePath);
    }
    ks.store(os, KeyStorePass);
    log.info(
            "Recording of certificates to " + keystoreName +
                    " is completed.");

}
}
