/**
 * $RCSfile: CheckConf.java,v $
 * version $Revision: 1.6 $
 * created 04.07.2007 14:31:39 by kunina
 * last modified $Date: 2009/04/21 11:44:18 $ by $Author: kunina $
 * (C)  - 2004-2007.
 *
 *  ,    , 
 *   .      
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package ComLine;

import java.security.KeyPairGenerator;
import java.security.NoSuchAlgorithmException;
import java.security.Provider;
import java.security.Security;
import java.util.logging.Logger;

/**
 *     .
 *
 * @author Copyright 2004-2007 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class CheckConf {
/**
 * logger
 */
private static Logger log = Logger.getLogger("LOGGER");

/**
 *
 */
private CheckConf() {
}

/**
 * CheckConf ( )
 *
 * @param args  
 * @throws Exception /
 */
public static void main(String[] args) throws Exception {
    if (ComLine.getFunc(ComLine.hllp, args))
        log.info(ComLine.HCheckConf + "   (without parameters)");
    else
        check();
}

/**
 *   
 *
 * @throws Exception 
 */
private static void check() throws Exception {
    //   
    final Provider[] provs = Security.getProviders();
    int flag_jcp = 0;
    int flag_crypto = 0;
    int flag_jtls = 0;
    String s = "";
    for (int i = 0; i < provs.length; i++) {
        //System.out.println(provs[i].getName());
        if ("JCP".equals(provs[i].getName()))
            flag_jcp = 1;
        if ("Crypto".equals(provs[i].getName()))
            flag_crypto |= 1;
        if ("JTLS".equals(provs[i].getName()))
            flag_jtls |= 1;
    }
    if (flag_jcp != 1) s = s + "  .\n";
    if (flag_crypto != 1) s = s + " Crypto  \n";
    if (flag_jtls != 1) s = s + " JTLS  \n";
    if (s.length() > 0) log.info(s + "\n\n :\n");
    else log.info(
            " JCP,Crypto,JTLS \n\n :\n");
    //    JCP
    final String[] sout = new String[3];
    int i = 0;
    try {
        final java.security.Signature sig =
                java.security.Signature.getInstance("GOST3411withGOST3410EL");
        sout[i] = " JCP  ";
        i++;
    } catch (NoSuchAlgorithmException e) {
        sout[i] = " JCP  .";
        i++;
    }
    //    Crypto
    try {
        final KeyPairGenerator keyGen =
                KeyPairGenerator.getInstance("GOST3410DHEPH");
        sout[i] = " Crypto  ";
        i++;
    } catch (NoSuchAlgorithmException e) {
        sout[i] = " Crypto  .";
        i++;
    }
    //    TLS
    int j = 0;
    String[] sout1 = new String[4];
    final String factoryProvider =
            Security.getProperty("ssl.SocketFactory.provider");
    if (factoryProvider == null ||
            !factoryProvider.equals("ru.CryptoPro.ssl.SSLSocketFactoryImpl")) {
        sout1[j] =
                "  ssl.SocketFactory.provider  java.security";
        j++;
    }
    final String serverProvider = Security
            .getProperty("ssl.ServerSocketFactory.provider");
    if (serverProvider == null || !serverProvider
            .equals("ru.CryptoPro.ssl.SSLServerSocketFactoryImpl")) {
        sout1[j] =
                "  ssl.ServerSocketFactory.provider  java.security";
        j++;
    }
    final String keyManager = Security
            .getProperty("ssl.KeyManagerFactory.algorithm");
    if (keyManager == null || !keyManager.equals("GostX509")) {
        sout1[j] =
                "  ssl.KeyManagerFactory.algorithm  java.security";
        j++;
    }
    final String trust = Security
            .getProperty("ssl.TrustManagerFactory.algorithm");
    if (trust == null || !trust.equals("GostX509")) {
        sout1[j] =
                "  ssl.TrustManagerFactory.algorithm  java.security";
        j++;
    }

    final int jmax = j - 1;
    if (j == 0) {
        sout[i] = " JTLS  ";
        i++;
    } else {
        String ss = "";
        for (int jj = 0; jj <= jmax; jj++) {
            ss = ss + "\n" + sout1[jj];
        }
        sout[i] = " JTLS  :" + ss;
        i++;
    }


    final int imax = i - 1;
    String Sout = "\n" + sout[0];
    for (i = 1; i <= imax; i++) {
        Sout = Sout + "\n" + sout[i];
    }
    log.info(Sout + "\n");
}
}
