package ComLine;

import java.io.IOException;
import java.util.Properties;
import java.util.logging.Logger;

/**
 *       (. JTLS_samples.Client).
 *
 * @author Copyright 2004-2007 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class Client {
/**
 * logger
 */
private static Logger log = Logger.getLogger("LOGGER");

 /**/
private Client() {
}

/**
 * Client [-port port] [-server serverName] [-keyStoreType HDImageStore]
 * [-trustStoreType HDImageStore] -trustStorePath C:/*.* -trustStorePassword
 * trust_pass -keyStorePassword key_pass [-fileget gettingFileName] [-fileout
 * outputFilePath]
 * <p/>
 * </DD> <DL> <DT><b> -port </b>  <DD>  <DD>(  443)</DD>
 * <DT><b> -server </b> <DD>  <DD>(  localhost)<br> <DT><b>
 * -keyStoreType </b> <DD>   HDImageStore ( ),
 * FloppyStore (), OCFStore  J6CFStore () <DD>( 
 * HDImageStore)</DD> <DT><b> -trustStoreType </b> <DD>  
 *    HDImageStore ( ), FloppyStore
 * () <DD>(  HDImageStore)</DD> <DT><b> -trustStorePath </b>
 * <DD>    </DD> <DT><b> -trustStorePassword
 * </b> <DD>    </DD> <DT><b>
 * -keyStorePassword </b>  <DD>  </DD> <DT><b> -fileget</b>  <DD>
 *  <DD>(  index.html)</DD> <DT><b> -fileout </b> <DD> 
 *   <DD>(  out.html)<br></DT> </DL>
 *
 * @param args   
 * @throws IOException  -
 */
public static void main(String[] args) throws IOException {
    if (ComLine.getFunc(ComLine.hllp, args)) log.info(ComLine.HELP_ClIENT);
    else
        try {
            //      
            //      
            final Properties ArgList = new Properties();
            //
            ArgList.setProperty(ComLine.PORT,
                    ComLine.getValue(ComLine.PORT, args, "443"));
            //
            ArgList.setProperty(ComLine.SERVER, ComLine.getValue(
                    ComLine.SERVER, args, "localhost"));
            //keyStoreType
            ArgList.setProperty(ComLine.keyStoreType,
                    ComLine.getValue(ComLine.keyStoreType, args,
                            ComLine.HDImageStore));
            //trustStoreType
            ArgList.setProperty(ComLine.trustStoreType,
                    ComLine.getValue(ComLine.trustStoreType, args,
                            ComLine.HDImageStore));
            //trustStorePath
            ArgList.setProperty(ComLine.trustStorePath,
                    ComLine.getValue(ComLine.trustStorePath, args, null));
            //keyStorePassword
            ArgList.setProperty(ComLine.keyStorePassword,
                    ComLine.getValue(ComLine.keyStorePassword, args, "null"));
            //trustStorePassword
            ArgList.setProperty(ComLine.trustStorePassword,
                    ComLine.getValue(ComLine.trustStorePassword, args, null));
            //Get file (filename)
            ArgList.setProperty(ComLine.fileget, ComLine.getValue(
                    ComLine.fileget, args, "index.html"));
            //file for output (fileout path)
            ArgList.setProperty(ComLine.fileout, ComLine.getValue(
                    ComLine.fileout, args, "out.html"));

            //  .
            //       HDImageStore.
            final String ks;
            ks = ArgList.getProperty(ComLine.keyStoreType);
            if (ks.equalsIgnoreCase(ComLine.HDImageStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.FloppyStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.OCFStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.J6CFStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.NO_STORE)) {
            } else {
                ArgList.setProperty(ComLine.keyStoreType, ComLine.HDImageStore);
                log.info("Incorrect keystore type: " + ks +
                        ". Value by default is appropriated: " + ComLine
                        .HDImageStore);
            }
            if (!"null"
                    .equalsIgnoreCase(
                            ArgList.getProperty(ComLine.keyStorePassword))) {
                final String keyStpass =
                        ArgList.getProperty(ComLine.keyStorePassword);
                System.setProperty("javax.net.ssl.keyStorePassword", keyStpass);
            }
            System.setProperty("javax.net.ssl.keyStoreType",ArgList.getProperty(ComLine.keyStoreType));

            System.setProperty("javax.net.ssl.trustStoreType",
                    ArgList.getProperty(ComLine.trustStoreType));
            System.setProperty("javax.net.ssl.trustStore",
                    ArgList.getProperty(ComLine.trustStorePath));
            System.setProperty("javax.net.ssl.trustStorePassword",
                    ArgList.getProperty(ComLine.trustStorePassword));

            System.setProperty("javax.net.ssl.supportGVO", "true");
//=============================================================================
            final int sslPort =
                    Integer.decode(ArgList.getProperty(ComLine.PORT))
                            .intValue();

            final String sslhost = ArgList.getProperty(ComLine.SERVER);

            final JTLS_samples.Client client =
                    new JTLS_samples.Client(sslhost, sslPort);
            client.setTimeout(100000);
            client.get(ArgList.getProperty(ComLine.fileget),
                    ArgList.getProperty(
                            ComLine.fileout), null);

        } catch (NullPointerException e) {
            log.info(ComLine.HELP_ClIENT);
        } catch (ArrayIndexOutOfBoundsException e) {
            log.info(ComLine.HELP_ClIENT);
//    } catch (Exception e) {
//        e.printStackTrace();
        }
}
}
