/**
 * $RCSfile: KeyPairGen.java,v $
 * version $Revision: 1.25 $
 * created 20.06.2007 17:15:15 by kunina
 * last modified $Date: 2009/09/25 13:12:13 $ by $Author: kunina $
 * (C)  - 2004-2007.
 *
 *  ,    , 
 *   .     
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package ComLine;

import ru.CryptoPro.JCPRequest.GostCertificateRequest;

import java.io.ByteArrayInputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.KeyStore;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.cert.Certificate;
import java.security.cert.CertificateFactory;
import java.util.Properties;
import java.util.logging.Logger;

/**
 *          34.10-2001 
 *    .    .
 *         .
 *
 * @kunina Copyright 2004-2007 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class KeyPairGen {
/**
 * logger
 */
private static Logger log = Logger.getLogger("LOGGER");

/**
 * forbidden.
 */
private KeyPairGen() {

}

/**
 * KeyPairGen -alias name_of_key [-alg GOST3410] [-storetype HDImageStore]
 * [-storepath null] [-storepass null] [-keypass password] [-isServer true]
 * -dname CN=autor,OU=Security,O=CryptoPro,C=RU -reqCertpath C:/*.* -encoding
 * der
 * <p/>
 * <DL> <DT><b> -alias </b>  <DD>   </DD> <DT><b>
 * -alg </b> <DD>  <DD>(  GOST3410)</DD>
 * <DT><b> -storetype </b> <DD>   HDImageStore (
 * ), FloppyStore (), OCFStore () <DD>( 
 * HDImageStore)</DD> <DT><b>-storepath </b>  <DD>   
 *  <DD>(  null)</DD> <DT><b> -storepass </b>  <DD>
 *     <DD>(  null)</DD> <DT><b>
 * -keypass </b> <DD>    <DD>(  null)</DD>
 * <DT><b>-isServer</b> <DD>  ,   true <DD>(
 *  false)</DD> <DT><b> -dname</b>  <DD>   
 *  </DD> <DT><b> -encoding</b>  <DD>
 * (DER/BASE64) <DD>(  DER)</DD> <DT><b> -reqCertpath </b> <DD>
 *   </DD></DT> </DL>
 *
 * @param args   
 */
public static void main(String[] args) {
    if (ComLine.getFunc(ComLine.hllp, args)) log.info(ComLine.KeyPairGenHelpHD);
    else
        try {
//----------------------------------------------------------------------------//
            //      
            //      
            final Properties ArgList = new Properties();
            //   
            ArgList.setProperty(ComLine.ALIAS,
                    ComLine.getValue(ComLine.ALIAS, args, null));
            //  
            ArgList.setProperty(ComLine.storetype,
                    ComLine.getValue(ComLine.storetype, args,
                            ComLine.HDImageStore));
            //    
            ArgList.setProperty(ComLine.storepath,
                    ComLine.getValue(ComLine.storepath, args, "null"));
            //    
            ArgList.setProperty(ComLine.storepass,
                    ComLine.getValue(ComLine.storepass, args, "null"));
            //   
            ArgList.setProperty(ComLine.keypass,
                    ComLine.getValue(ComLine.keypass, args, "null"));
            //     
            ArgList.setProperty(ComLine.dname,
                    ComLine.getValue(ComLine.dname, args, null));
            //   34.10-2001 (   )
            ArgList.setProperty(ComLine.KeyPairAlgoritm,
                    ComLine.getValue(ComLine.alg, args, "GOST3410"));
            //   GostCertificateRequest EncodedSelfCert
            ArgList.setProperty(ComLine.reqCertpath,
                    ComLine.getValue(ComLine.reqCertpath, args, null));
            //  
            ArgList.setProperty(ComLine.isServer,
                    ComLine.getValue(ComLine.isServer, args, "false"));
            //    
            ArgList.setProperty(ComLine.encoding,
                    ComLine.getValue(ComLine.encoding, args, "der"));

            //  .
            //       HDImageStore.
            final String ks;
            ks = ArgList.getProperty(ComLine.storetype);
            if (ks.equalsIgnoreCase(ComLine.HDImageStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.FloppyStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.OCFStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.J6CFStore)) {
            } else {
                ArgList.setProperty(ComLine.storetype, ComLine.HDImageStore);
                log.info("Incorrect keystore type: " + ks +
                        ". Value by default is appropriated: " + ComLine
                        .HDImageStore);
            }
            //     (  )
            final String nf;
            nf = ArgList.getProperty(ComLine.dname);
            final String[] nfs = nf.split(",");
            for (int i = 0; i < nfs.length; i++) {
                final String[] ss = nfs[i].split("=");
                if ("C".equals(ss[0]) && ss[1].length() != 2)
                    throw new Exception("Incorrect name of the certificate");
            }
//============================================================================//
            //         34.10-2001
            //    .
            //   .     (DER)  
            keyGen(
                    ArgList.getProperty(ComLine.ALIAS),
                    ArgList.getProperty(ComLine.KeyPairAlgoritm),
                    ArgList.getProperty(ComLine.storetype),
                    ArgList.getProperty(ComLine.keypass),
                    ArgList.getProperty(ComLine.dname),
                    ArgList.getProperty(ComLine.storepass),
                    ArgList.getProperty(ComLine.storepath),
                    ArgList.getProperty(ComLine.reqCertpath),
                    ArgList.getProperty(ComLine.isServer),
                    ArgList.getProperty(ComLine.encoding));

        } catch (NullPointerException e) {
            log.info(ComLine.KeyPairGenHelpHD);
        } catch (IllegalArgumentException e) {
            log.info("\n" +
                    e.toString() + "\n" + ComLine.KeyPairGenHelpHD);
        } catch (ArrayIndexOutOfBoundsException e) {
            log.info(ComLine.KeyPairGenHelpHD);
        } catch (Exception e) {
            e.printStackTrace();
        }

}

/**
 *       .
 *
 * @param alias    
 * @param keypairAlgorithm    34.10-2001 ( .
 * )
 * @param keystoreName   
 * @param keypass    
 * @param name      
 * @param keystorePass     
 * @param keystorePath     
 * @param reqpath      
 * @param server true -   , false -  
 * 
 * @param encoding der -    der-, base64 -  
 *  base64-
 * @throws Exception ...
 */
private static void keyGen(String alias, String keypairAlgorithm,
                           String keystoreName, String keypass, String name,
                           String keystorePass, String keystorePath,
                           String reqpath, String server, String encoding)
        throws Exception {
    //  
    final KeyPairGenerator kg =
            KeyPairGenerator.getInstance(keypairAlgorithm);
    final KeyPair pair = kg.generateKeyPair();
    //log.info("Generation of key pair is completed");

    //  
    final GostCertificateRequest req;
    req = new GostCertificateRequest();
    boolean isServer = false;
    if ("true".equalsIgnoreCase(server)) isServer = true;
    req.init(keypairAlgorithm, isServer);
    final byte[] encodedCert = req.getEncodedSelfCert(pair, name);

    //  
    final CertificateFactory cf = CertificateFactory.getInstance("X509");
    final Certificate[] certs;
    certs = new Certificate[1];
    certs[0] =
            cf.generateCertificate(new ByteArrayInputStream(encodedCert));
    //log.info("Generation of certificate is completed"); /**/

    //       
    final KeyStore ks = KeyStore.getInstance(keystoreName);
    char[] KeyStorePass = null;
    if (!"null".equalsIgnoreCase(keystorePass)) {
        KeyStorePass = keystorePass.toCharArray();
    }
    InputStream is = null;
    if (!"null".equalsIgnoreCase(keystorePath)) {
        is = new FileInputStream(keystorePath);
    }
    ks.load(is, KeyStorePass);/**/
    final PrivateKey key;
    key = pair.getPrivate();
    char[] Keypass = null;
    if (!"null".equalsIgnoreCase(keypass)) {
        Keypass = keypass.toCharArray();
    }
    ks.setKeyEntry(alias, key, Keypass, certs);
    OutputStream os = null;
    if (!"null".equalsIgnoreCase(keystorePath)) {
        os = new FileOutputStream(keystorePath);
    }
    ks.store(os, KeyStorePass);
    log
            .info("Recording of a private key named \"" + alias + "\" to " +
                    keystoreName + " is completed. Request: " + reqpath);

//----------------------------------------------------------------------------//
    //  (DER )
    //    
    final PublicKey publicKey = pair.getPublic();
//    boolean isServer = false;
//    if ("true".equalsIgnoreCase(server)) isServer = true;
//    req.init(keypairAlgorithm, isServer);
    req.setPublicKeyInfo(publicKey);
    //  
    req.setSubjectInfo(name);
    //   
    final PrivateKey privateKey = pair.getPrivate();
    req.encodeAndSign(privateKey);

    //  
    boolean toBASE64 = false;
    if ("base64".equalsIgnoreCase(encoding)) toBASE64 = true;
    FileOutputStream fos = null;
    try {
        fos = new FileOutputStream(reqpath);
        final PrintStream stream = new PrintStream(fos);
        if (toBASE64)
            req.printToBASE64(stream);
        else
            req.printToDER(stream);
    } finally {
        if (fos != null) fos.close();
    }
//----------------------------------------------------------------------------//
    //   ,     

    /*String httpAddress = "http://www.cryptopro.ru/certsrv/";

    byte[] encCert = req.getEncodedCert(httpAddress);
    Certificate aliascert = cf.generateCertificate(new ByteArrayInputStream(encCert));
    // 
    ks.load(is, KeyStorePass);
    ks.setCertificateEntry(alias,aliascert);
    ks.store(os, KeyStorePass);

    // 
    ks.load(is, KeyStorePass);
    Certificate Cert = ks.getCertificate(alias);
    byte[] encoCert = Cert.getEncoded();
    ks.store(os, KeyStorePass);
    FileOutputStream fost = null;
    try {
        fost = new FileOutputStream("D:\\Job\\test\\myData\\prKey.cer");
        fost.write(encoCert);
    } finally {
        if (fost!=null) fost.close();
    } /**/

}


}
