package ComLine;

import java.io.File;
import java.io.IOException;
import java.util.Properties;
import java.util.logging.Logger;

/**
 *       (. JTLS_samples.Server).
 * <p/>
 *   "shutdown"   ...
 *
 * @author Copyright 2004-2007 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class Server {
/**
 * logger
 */
private static Logger log = Logger.getLogger("LOGGER");

 /**/
private Server() {
}

/**
 * Server [-port port] [-auth true] [-keyStoreType HDImageStore]
 * [-trustStoreType HDImageStore] -trustStorePath C:/*.* -trustStorePassword
 * trust_pass -keyStorePassword key_pass
 * <p/>
 * </DD> <DL> <DT><b> -port </b>  <DD>  <DD>(  443)</DD>
 * <DT><b> -auth </b> <DD>    <DD>( 
 * false)<br> <DT><b> -keyStoreType </b> <DD>   HDImageStore
 * ( ), FloppyStore (), OCFStore  J6CFStore ()
 * <DD>(  HDImageStore)</DD> <DT><b> -trustStoreType </b> <DD>
 *      HDImageStore ( ),
 * FloppyStore () <DD>(  HDImageStore)</DD> <DT><b>
 * -trustStorePath </b> <DD>    </DD>
 * <DT><b> -trustStorePassword </b> <DD>   
 * </DD> <DT><b> -keyStorePassword </b>  <DD>  </DD>
 * <DT><b> -servDir </b>  <DD>   <DD>( 
 * )</DD></DT> </DL>
 *
 * @param args   
 * @throws IOException  -
 */
public static void main(String[] args) throws IOException {
    if (ComLine.getFunc(ComLine.hllp, args)) log.info(ComLine.HELP_SERV);
    else
        try {
            //      
            //      
            final Properties ArgList = new Properties();
            //
            ArgList.setProperty(ComLine.PORT,
                    ComLine.getValue(ComLine.PORT, args, "443"));
            //keyStoreType
            ArgList.setProperty(ComLine.keyStoreType,
                    ComLine.getValue(ComLine.keyStoreType, args,
                            ComLine.HDImageStore));
            //trustStoreType
            ArgList.setProperty(ComLine.trustStoreType,
                    ComLine.getValue(ComLine.trustStoreType, args,
                            ComLine.HDImageStore));
            //trustStorePath
            ArgList.setProperty(ComLine.trustStorePath,
                    ComLine.getValue(ComLine.trustStorePath, args, null));
            //keyStorePassword
            ArgList.setProperty(ComLine.keyStorePassword,
                    ComLine.getValue(ComLine.keyStorePassword, args, "null"));
            //trustStorePassword
            ArgList.setProperty(ComLine.trustStorePassword,
                    ComLine.getValue(ComLine.trustStorePassword, args, null));
            //autentification of client
            ArgList.setProperty(ComLine.auth,
                    ComLine.getValue(ComLine.auth, args, "false"));
            //server working dir
            ArgList.setProperty(ComLine.servDir,
                    ComLine.getValue(ComLine.servDir,
                            args, new File(".").getCanonicalPath()));

            //  .
            //       HDImageStore.
            final String ks;
            ks = ArgList.getProperty(ComLine.keyStoreType);
            if (ks.equalsIgnoreCase(ComLine.HDImageStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.FloppyStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.OCFStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.J6CFStore)) {
            } else {
                ArgList.setProperty(ComLine.storetype, ComLine.HDImageStore);
                log.info("Incorrect keystore type: " + ks +
                        ". Value by default is appropriated: " + ComLine
                        .HDImageStore);
            }
            if (!"null"
                    .equalsIgnoreCase(
                            ArgList.getProperty(ComLine.keyStorePassword))) {
                final String keyStpass =
                        ArgList.getProperty(ComLine.keyStorePassword);
                System.setProperty("javax.net.ssl.keyStorePassword", keyStpass);
            }
            //
            if (!new File(ArgList.getProperty(ComLine.servDir)).isDirectory())
                ArgList.setProperty(ComLine.servDir,
                        new File(".").getCanonicalPath());

            System.setProperty("javax.net.ssl.keyStoreType",
                    ArgList.getProperty(ComLine.keyStoreType));

            System.setProperty("javax.net.ssl.trustStoreType",
                    ArgList.getProperty(ComLine.trustStoreType));
            System.setProperty("javax.net.ssl.trustStore",
                    ArgList.getProperty(ComLine.trustStorePath));
            System.setProperty("javax.net.ssl.trustStorePassword",
                    ArgList.getProperty(ComLine.trustStorePassword));

            System.setProperty("javax.net.ssl.supportGVO", "true");
//=============================================================================
            final int sslPort =
                    Integer.decode(ArgList.getProperty(ComLine.PORT))
                            .intValue();
            boolean auth = false;
            if (ArgList.getProperty(ComLine.auth).equalsIgnoreCase("true"))
                auth = true;
            //   auth
            final JTLS_samples.Server server = new JTLS_samples.Server(sslPort,
                    auth, ArgList.getProperty(ComLine.servDir));
            server.setTimeout(100000);
            server.start();
            if (!server.isAlive()) throw new IOException();
        } catch (NullPointerException e) {
            log.info(ComLine.HELP_SERV);
        } catch (ArrayIndexOutOfBoundsException e) {
            log.info(ComLine.HELP_SERV);
//    } catch (Exception e) {
//        e.printStackTrace();
        }
}
}
