/**
 * $RCSfile: getCert.java,v $
 * version $Revision: 1.11 $
 * created 26.06.2007 14:59:43 by kunina
 * last modified $Date: 2009/09/25 13:12:13 $ by $Author: kunina $
 * (C)  - 2004-2007.
 *
 *  ,    , 
 *   .      
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package ComLine;

import ru.CryptoPro.JCPRequest.GostCertificateRequest;

import java.io.ByteArrayInputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.KeyStore;
import java.security.cert.Certificate;
import java.security.cert.CertificateFactory;
import java.util.Properties;
import java.util.logging.Logger;

/**
 *    ,   DER-  
 *      
 *
 * @author Copyright 2004-2007 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class getCert {
/**
 * logger
 */
private static Logger log = Logger.getLogger("LOGGER");

/**
 * forbidden
 */
private getCert() {
}

/**
 * getCert -alias name_of_key [-storetype HDImageStore] [-storepath null]
 * [-storepass null] -http http://www.cryptopro.ru/certsrv/ -certpath C:/*.cer
 * -reqCertpath C:/*.*
 * <p/>
 * <DL> <DT><b> -alias </b>  <DD>  </DD> <DT><b> -storetype
 * </b> <DD>   HDImageStore ( ), FloppyStore
 * (), OCFStore  J6CFStore ()<DD>( 
 * HDImageStore)</DD> <DT><b>-storepath </b> <DD>   
 *  <DD>(  null)</DD> <DT><b> -storepass </b> <DD>
 *     <DD>(  null)</DD> <DT><b>
 * -http </b> <DD>   </DD> <DT><b> -reqCertpath</b>
 * <DD>    </DD> <DT><b> -encoding</b>  <DD> 
 * (DER/BASE64)<DD>(  DER)</DD> <DT><b> -ertpath</b> <DD>  
 *   </DD></DT> </DL>
 *
 * @param args   
 */
public static void main(String[] args) {
    if (ComLine.getFunc(ComLine.hllp, args)) log.info(ComLine.CertsHelpHD);
    else
        try {
            //      
            //      
            final Properties ArgList = new Properties();
            //  
            ArgList.setProperty(ComLine.ALIAS,
                    ComLine.getValue(ComLine.ALIAS, args, null));
            //  
            ArgList.setProperty(ComLine.storetype,
                    ComLine.getValue(ComLine.storetype, args,
                            ComLine.HDImageStore));
            //    
            ArgList.setProperty(ComLine.storepath,
                    ComLine.getValue(ComLine.storepath, args, "null"));
            //    
            ArgList.setProperty(ComLine.storepass,
                    ComLine.getValue(ComLine.storepass, args, "null"));
            //   
            ArgList.setProperty(ComLine.http,
                    ComLine.getValue(ComLine.http, args, null));
            //    
            ArgList.setProperty(ComLine.reqCertpath,
                    ComLine.getValue(ComLine.reqCertpath, args, null));
            //     
            ArgList.setProperty(ComLine.certpath,
                    ComLine.getValue(ComLine.certpath, args, null));
            // 
            ArgList.setProperty(ComLine.encoding,
                    ComLine.getValue(ComLine.encoding, args, "der"));

            //  .
            //       HDImageStore.
            final String ks;
            ks = ArgList.getProperty(ComLine.storetype);
            if (ks.equalsIgnoreCase(ComLine.HDImageStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.FloppyStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.OCFStore)) {
            } else if (ks.equalsIgnoreCase(ComLine.J6CFStore)) {
            } else {
                ArgList.setProperty(ComLine.storetype, ComLine.HDImageStore);
                log.info("Incorrect keystore type: " + ks +
                        ". Value by default is appropriated: " + ComLine
                        .HDImageStore);
            }

            //    
            getCert(
                    ArgList.getProperty(ComLine.ALIAS),
                    ArgList.getProperty(ComLine.reqCertpath),
                    ArgList.getProperty(ComLine.storetype),
                    ArgList.getProperty(ComLine.storepass),
                    ArgList.getProperty(ComLine.storepath),
                    ArgList.getProperty(ComLine.http),
                    ArgList.getProperty(ComLine.certpath),
                    ArgList.getProperty(ComLine.encoding));

        } catch (NullPointerException e) {
            //System.out.println(e.toString());
            log.info(ComLine.GetCertHelpHD);
        } catch (Exception e1) {
            final String sss = "java.lang.Exception:";
            log.info("\n" +
                    e1.toString()
                            .substring(sss.length(), e1.toString().length()) +
                    "\n" + ComLine.GetCertHelpHD);
        }

}

/**
 * @param alias  
 * @param reqpath     
 * @param keystoreName   
 * @param keystorePass     
 * @param keystorePath     
 * @param httpAddr    
 * @param cerpath      
 * @param encoding  
 * @throws Exception ...
 */
private static void getCert(String alias,
                            String reqpath,
                            String keystoreName,
                            String keystorePass,
                            String keystorePath,
                            String httpAddr,
                            String cerpath,
                            String encoding) throws Exception {

    //   
    InputStream is = null;
    FileOutputStream fost = null;
    final byte[] encodedCert;
    try {
        is = new FileInputStream(reqpath);
        if ("base64".equals(encoding)) {
            //   ,   BASE64 
            encodedCert =
                    GostCertificateRequest.getEncodedCertFromDER(httpAddr, is);
        } else {
            //   ,   DER 
            encodedCert =
                    GostCertificateRequest.getEncodedCertFromDER(httpAddr, is);
        }
        //  
        fost = new FileOutputStream(cerpath);
        fost.write(encodedCert);

        //  
        final KeyStore ks = KeyStore.getInstance(keystoreName);
        char[] KeyStorePass = null;
        if (!"null".equalsIgnoreCase(keystorePass)) {
            KeyStorePass = keystorePass.toCharArray();
        }
        InputStream Is = null;
        if (!"null".equalsIgnoreCase(keystorePath)) {
            Is = new FileInputStream(keystorePath);
        }
        ks.load(Is, KeyStorePass);

        final CertificateFactory cf = CertificateFactory.getInstance("X509");
        final Certificate cert;
        cert = cf.generateCertificate(new ByteArrayInputStream(encodedCert));
        ks.setCertificateEntry(alias, cert);
        OutputStream os = null;
        if (!"null".equalsIgnoreCase(keystorePath)) {
            os = new FileOutputStream(keystorePath);
        }
        ks.store(os, KeyStorePass);
        log.info(
                "Recording of a certificate to " + cerpath + " and to " +
                        keystoreName + " is completed.");
    } finally {
        if (is != null) is.close();
        if (fost != null) fost.close();
    }


}
}
