/**
 * $RCSfile: Decrypt.java,v $
 * version $Revision: 1.1 $
 * created 16.02.2009 12:39:55 by kunina
 * last modified $Date: 2009/02/16 13:03:27 $ by $Author: kunina $
 * (C)  - 2004-2009.
 *
 *  ,    , 
 *   .      
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package Crypt_samples;

import com.objsys.asn1j.runtime.Asn1BerEncodeBuffer;
import com.objsys.asn1j.runtime.Asn1Exception;
import ru.CryptoPro.JCP.ASN.Gost28147_89_EncryptionSyntax.Gost28147_89_EncryptedKey;
import ru.CryptoPro.JCP.ASN.Gost28147_89_EncryptionSyntax.Gost28147_89_Key;
import ru.CryptoPro.JCP.ASN.Gost28147_89_EncryptionSyntax.Gost28147_89_MAC;
import ru.CryptoPro.JCP.tools.Array;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.KeyAgreement;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.UnrecoverableKeyException;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.util.Arrays;

/**
 *        .
 * <p/>
 *   Encrypt.java    CSP (...\samples\CSP\EncryptFile)
 * <p/>
 *         
 * (. GenKeys.java)
 *
 * @author Copyright 2004-2009 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class Decrypt {
/**
 *   
 */
private static PrivateKey responderPrivateKey;
/**
 *    ( )
 */
private static PublicKey senderPublicKey;
/**
 * 
 */
private static IvParameterSpec sv;
/**
 *  
 */
private static IvParameterSpec iv;
/**
 *  
 */
private static final String W_PATH = GenKeys.W_PATH;
/**
 *  
 */
private static final String RESPONDER = GenKeys.RESPONDER;
/**
 *  
 */
private static final String SENDER = GenKeys.SENDER;
/**
 * 
 */
private static final String F_SEP = File.separator;

/**
 * @param args *
 * @throws Exception /
 */
public static void main(String[] args) throws Exception {
    prepareForSample();
    unWrapAndDecrypt();
}

/**
 *    
 *
 * @param filePath  
 * @return Certificate
 * @throws FileNotFoundException /
 * @throws CertificateException /
 */
private static Certificate generateCert(String filePath)
        throws FileNotFoundException, CertificateException {
    final CertificateFactory cf = CertificateFactory.getInstance("X509");
    return cf.generateCertificate(new FileInputStream(filePath));
}

/**
 *    
 *
 * @throws NoSuchAlgorithmException /
 * @throws KeyStoreException /
 * @throws IOException /
 * @throws CertificateException /
 * @throws UnrecoverableKeyException /
 */
private static void prepareForSample()
        throws NoSuchAlgorithmException, KeyStoreException, IOException,
        CertificateException, UnrecoverableKeyException {
    //    (. GenKeys.java)
    // 
    final KeyStore ks = KeyStore.getInstance("HDImageStore");
    ks.load(null, null);
    responderPrivateKey = (PrivateKey) ks.getKey(RESPONDER, null);
    // 
    final Certificate responderCert =
            generateCert(W_PATH + F_SEP + SENDER + GenKeys.CERT_EXT);
    senderPublicKey = responderCert.getPublicKey();
    //       
    // 
    sv = new IvParameterSpec(Array.readFile(W_PATH + F_SEP + "session_SV.bin"));
    iv = new IvParameterSpec(Array.readFile(W_PATH + F_SEP + "vector.bin"));
}

/**
 *      
 *
 * @throws NoSuchAlgorithmException /
 * @throws InvalidAlgorithmParameterException /
 * @throws InvalidKeyException /
 * @throws NoSuchPaddingException /
 * @throws IOException /
 * @throws Asn1Exception /
 * @throws BadPaddingException /
 * @throws IllegalBlockSizeException /
 */
private static void unWrapAndDecrypt() throws NoSuchAlgorithmException,
        InvalidAlgorithmParameterException, InvalidKeyException,
        NoSuchPaddingException, IOException, Asn1Exception, BadPaddingException,
        IllegalBlockSizeException {

    //      key
    final KeyAgreement keyAgree = KeyAgreement.getInstance("GOST3410DH");
    keyAgree.init(responderPrivateKey, sv, null);
    keyAgree.doPhase(senderPublicKey, true);
    final SecretKey secretKey = keyAgree.generateSecret("GOST28147");

    // 
    Cipher cipher = Cipher.getInstance("GOST28147/PRO_EXPORT/NoPadding");

    //key
    final Gost28147_89_EncryptedKey ek = new Gost28147_89_EncryptedKey();
    final byte[] enc =
            Array.readFile(W_PATH + F_SEP + "session_EncryptedKey.bin");
    ek.encryptedKey = new Gost28147_89_Key(enc);
    //mac
    final byte[] mc = Array.readFile(W_PATH + F_SEP + "session_MacKey.bin");
    ek.macKey = new Gost28147_89_MAC(mc);

    final Asn1BerEncodeBuffer ebuf = new Asn1BerEncodeBuffer();
    ek.encode(ebuf);
    final byte[] wrap = ebuf.getMsgCopy();
    // 
    cipher.init(Cipher.UNWRAP_MODE, secretKey, sv);
    final SecretKey key_ =
            (SecretKey) cipher.unwrap(wrap, null, Cipher.SECRET_KEY);
    final byte[] encr = Array.readFile(W_PATH + F_SEP + "encrypt.bin");

    //    key_
    cipher = Cipher.getInstance("GOST28147");
    cipher.init(Cipher.DECRYPT_MODE, key_, iv);
    final byte[] decr_ = cipher.doFinal(encr);

    final byte[] txt = Array.readFile(W_PATH + F_SEP + "source.txt");

    if (Arrays.equals(txt, decr_)) System.out.println("OK");
}
}
