/**
 * $RCSfile: Encrypt.java,v $
 * version $Revision: 1.1 $
 * created 16.02.2009 12:39:34 by kunina
 * last modified $Date: 2009/02/16 13:03:27 $ by $Author: kunina $
 * (C)  - 2004-2009.
 *
 *  ,    , 
 *   .      
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package Crypt_samples;

import com.objsys.asn1j.runtime.Asn1BerDecodeBuffer;
import com.objsys.asn1j.runtime.Asn1Exception;
import ru.CryptoPro.JCP.ASN.Gost28147_89_EncryptionSyntax.Gost28147_89_EncryptedKey;
import ru.CryptoPro.JCP.ASN.Gost28147_89_EncryptionSyntax.Gost28147_89_Key;
import ru.CryptoPro.JCP.ASN.Gost28147_89_EncryptionSyntax.Gost28147_89_MAC;
import ru.CryptoPro.JCP.tools.Array;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.KeyAgreement;
import javax.crypto.KeyGenerator;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.UnrecoverableKeyException;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.util.Arrays;
import java.util.Random;

/**
 *        .
 * <p/>
 *   Decrypt.java    CSP (...\samples\CSP\DecryptFile)
 * <p/>
 *         
 * (. GenKeys.java)
 *
 * @author Copyright 2004-2009 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class Encrypt {
/**
 *   
 */
private static final Random rnd = new Random();
/**
 *   
 */
private static PrivateKey senderPrivateKey;
/**
 *    ( )
 */
private static PublicKey responderPublicKey;
/**
 * 
 */
private static IvParameterSpec sv;
/**
 *  
 */
private static IvParameterSpec iv;
/**
 * 
 */
private static final byte[] TEXT = new byte[]{1, 2, 3, 4, 5, 6, 7, 8, 9, 0};
/**
 *  
 */
private static final String W_PATH = GenKeys.W_PATH;
/**
 *  
 */
private static final String RESPONDER = GenKeys.RESPONDER;
/**
 *  
 */
private static final String SENDER = GenKeys.SENDER;
/**
 * 
 */
private static final String F_SEP = File.separator;

/**
 * @param args *
 * @throws Exception /
 */
public static void main(String[] args) throws Exception {
    prepareForSample();
    wrapAndEncrypt();
}

/**
 *      
 *
 * @return IvParameterSpec
 */
private static IvParameterSpec generateNewSyncro() {
    final byte[] syncro = new byte[8];
    for (int j = 0; j < 8; j++) syncro[j] = (byte) rnd.nextInt();
    return new IvParameterSpec(syncro);
}

/**
 *    
 *
 * @param filePath  
 * @return Certificate
 * @throws FileNotFoundException /
 * @throws CertificateException /
 */
private static Certificate generateCert(String filePath)
        throws FileNotFoundException, CertificateException {
    final CertificateFactory cf = CertificateFactory.getInstance("X509");
    return cf.generateCertificate(new FileInputStream(filePath));
}

/**
 *    
 *
 * @throws NoSuchAlgorithmException /
 * @throws KeyStoreException /
 * @throws IOException /
 * @throws CertificateException /
 * @throws UnrecoverableKeyException /
 */
private static void prepareForSample()
        throws NoSuchAlgorithmException, KeyStoreException, IOException,
        CertificateException, UnrecoverableKeyException {
    //    (. GenKeys.java)
    // 
    final KeyStore ks = KeyStore.getInstance("HDImageStore");
    ks.load(null, null);
    senderPrivateKey = (PrivateKey) ks.getKey(SENDER, null);
    // 
    final Certificate responderCert =
            generateCert(W_PATH + F_SEP + RESPONDER + GenKeys.CERT_EXT);
    responderPublicKey = responderCert.getPublicKey();
    //      
    // 
    sv = generateNewSyncro();
    iv = generateNewSyncro();
}

/**
 *     
 *
 * @throws NoSuchAlgorithmException /
 * @throws NoSuchPaddingException /
 * @throws InvalidAlgorithmParameterException /
 * @throws InvalidKeyException /
 * @throws IllegalBlockSizeException /
 * @throws IOException /
 * @throws Asn1Exception /
 * @throws BadPaddingException /
 */
private static void wrapAndEncrypt()
        throws NoSuchAlgorithmException, NoSuchPaddingException,
        InvalidAlgorithmParameterException, InvalidKeyException,
        IllegalBlockSizeException, IOException, Asn1Exception,
        BadPaddingException {

    // 
    final KeyGenerator kg = KeyGenerator.getInstance("GOST28147");
    final SecretKey key = kg.generateKey();

    //      key
    final KeyAgreement keyAgree = KeyAgreement.getInstance("GOST3410DH");
    keyAgree.init(senderPrivateKey, sv, null);
    keyAgree.doPhase(responderPublicKey, true);
    final SecretKey secretKey = keyAgree.generateSecret("GOST28147");

    // 
    Cipher cipher = Cipher.getInstance("GOST28147/PRO_EXPORT/NoPadding");
    // 
    cipher.init(Cipher.WRAP_MODE, secretKey, sv);
    final byte[] wrap = cipher.wrap(key);

    final Asn1BerDecodeBuffer buf = new Asn1BerDecodeBuffer(wrap);
    final Gost28147_89_EncryptedKey ek = new Gost28147_89_EncryptedKey();
    ek.decode(buf);
    //key
    final Gost28147_89_Key enk = ek.encryptedKey;
    //mac
    final Gost28147_89_MAC mac = ek.macKey;

    //    key
    cipher = Cipher.getInstance("GOST28147");
    cipher.init(Cipher.ENCRYPT_MODE, key, iv);
    final byte[] encr = cipher.doFinal(TEXT);

    Array.writeFile(W_PATH + F_SEP + "encrypt.bin", encr);
    Array.writeFile(W_PATH + F_SEP + "session_EncryptedKey.bin", enk.value);
    Array.writeFile(W_PATH + F_SEP + "session_MacKey.bin", mac.value);
    Array.writeFile(W_PATH + F_SEP + "source.txt", TEXT);
    Array.writeFile(W_PATH + F_SEP + "session_SV.bin", sv.getIV());
    Array.writeFile(W_PATH + F_SEP + "vector.bin", iv.getIV());

    //
    //  key=key_
    cipher.init(Cipher.UNWRAP_MODE, secretKey, sv);
    final SecretKey key_ =
            (SecretKey) cipher.unwrap(wrap, null, Cipher.SECRET_KEY);

    //    key_
    cipher.init(Cipher.DECRYPT_MODE, key_, iv);
    final byte[] decr_ = cipher.doFinal(encr);

    if (Arrays.equals(TEXT, decr_)) System.out.println("OK");
}

}
