/**
 * $RCSfile: GenKeys.java,v $
 * version $Revision: 1.2 $
 * created 16.02.2009 13:18:24 by kunina
 * last modified $Date: 2009/02/16 13:43:26 $ by $Author: kunina $
 * (C)  - 2004-2009.
 *
 *  ,    , 
 *   .      
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package Crypt_samples;

import ru.CryptoPro.JCP.tools.Array;
import ru.CryptoPro.JCPRequest.GostCertificateRequest;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.security.InvalidKeyException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.SignatureException;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;

/**
 *     Encrypt.java  Decrypt.java
 *
 * @author Copyright 2004-2009 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class GenKeys {
/**
 *   (, )
 */
public static final String SENDER = "Sender";
/**
 *   (, )
 */
public static final String RESPONDER = "Responder";
/**
 *  
 */
public static String W_PATH = "E:\\test_dir";
/**
 *   
 */
public static final String CERT_EXT = ".cer";

/**
 * @param args *
 * @throws Exception /
 */
public static void main(String[] args) throws Exception {
    //    Encrypt  Decrypt
    createContainer(SENDER);
    createContainer(RESPONDER);
    // 
    expCert(SENDER, W_PATH);
    expCert(RESPONDER, W_PATH);
}

/**
 * @param name 
 * @param pathh  
 * @throws KeyStoreException /
 * @throws NoSuchAlgorithmException /
 * @throws IOException /
 * @throws CertificateException /
 */
private static void expCert(String name, String pathh) throws KeyStoreException,
        NoSuchAlgorithmException, IOException, CertificateException {
    final KeyStore ks = KeyStore.getInstance("HDImageStore");
    ks.load(null, null);
    final Certificate cert = ks.getCertificate(name);
    Array.writeFile(pathh + File.separator + name + CERT_EXT,
            cert.getEncoded());
}

/**
 * @param name  
 * @throws NoSuchAlgorithmException /
 * @throws IOException /
 * @throws SignatureException /
 * @throws InvalidKeyException /
 * @throws CertificateException /
 * @throws KeyStoreException /
 */
private static void createContainer(String name)
        throws NoSuchAlgorithmException, IOException, SignatureException,
        InvalidKeyException, CertificateException, KeyStoreException {
    final KeyPairGenerator kg = KeyPairGenerator.getInstance("GOST3410DH");
    final KeyPair keyPair = kg.generateKeyPair();
    //  ()
    final GostCertificateRequest req = new GostCertificateRequest();
    req.init("GOST3410DH", false);
    final byte[] encodedCert = req.getEncodedSelfCert(keyPair, "CN=" + name);

    //  
    final CertificateFactory cf = CertificateFactory.getInstance("X509");
    final Certificate[] certs;
    certs = new Certificate[1];
    certs[0] = cf.generateCertificate(new ByteArrayInputStream(encodedCert));

    //       
    final KeyStore ks = KeyStore.getInstance("HDImageStore");
    ks.load(null, null);
    ks.setKeyEntry(name, keyPair.getPrivate(), null, certs);
}
}
