/**
 * $RCSfile: Client.java,v $
 * version $Revision: 1.15 $
 * created 03.07.2007 10:07:20 by kunina
 * last modified $Date: 2009/05/18 09:45:03 $ by $Author: kunina $
 * (C)  - 2004-2007.
 *
 *  ,    , 
 *   .      
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package JTLS_samples;

import ru.CryptoPro.ssl.SSLSocketFactoryImpl;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.logging.Level;
import java.util.logging.Logger;


/**
 *  .
 *
 * @author Copyright 2004-2007 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class Client {

 /**/
public static final String hhtp_header_separator = "\r\n\r\n";
 /**/
public static final int DEFAULT_TIMEOUT = 1000;
 /**/
private int timeout = DEFAULT_TIMEOUT;
 /**/
private String host;
 /**/
private int port;
 /**/
private static String TEST_DIR = null;
 /**/
private static Logger log = Logger.getLogger("LOG");

/**
 *       .
 *
 * @param hostname 
 * @param p 
 */
public Client(String hostname, int p) {
    host = hostname;
    port = p;
}

/**
 *   timeout  .
 *
 * @param t timeout
 */
public void setTimeout(int t) {
    timeout = t;
}

/**
 *    .
 *
 * @param fileName  
 * @throws IOException  -
 */
public void get(String fileName, String outFileName, String testDir)
        throws IOException {
    TEST_DIR = testDir;
    Socket soc = null;
    try {
//        // 1
//        final SSLSocketFactory sslFact =
//                (SSLSocketFactory) SSLSocketFactory.getDefault();
        // 2
        final SSLSocketFactoryImpl sslFact = new SSLSocketFactoryImpl();

        soc = sslFact.createSocket(host, port);
        soc.setSoTimeout(timeout);
        proc(soc, fileName, outFileName);
    } finally {
        if (soc != null)
            soc.close();
    }
}

/**
 *     .
 *
 * @param soc 
 * @param file  
 * @param outfile   
 * @throws IOException  -
 */
public static void proc(Socket soc, String file, String outfile)
        throws IOException {
    final InputStream in = soc.getInputStream();
    final OutputStream out = soc.getOutputStream();
    // 
    final String req = "GET /" + file + " HTTP/1.0\r\n\r\n";
    log.log(Level.INFO, " Client request: " + req);
    out.write(req.getBytes());
    out.flush();
    // 
    log.log(Level.INFO, " Client: parse answer");
    final String answer =
            new String(readHeader(in, hhtp_header_separator.getBytes()));
    //System.out.println("---------------");
    //System.out.println(answer);
    int fileLength = 0;
    try {
        fileLength = parseAnswer(answer);
    } catch (IOException e) {
        //ignore
    }
    //
    final byte[] body = readBody(in, fileLength);
//    final FileOutputStream fost =
//            new FileOutputStream(outfile + new File(file).getName() + "body");
//    fost.write(body);
//    fost.close();
    //
    boolean isread = true;
    byte[] buffer = body;
    if (TEST_DIR != null)
        try {
            buffer = readFile(TEST_DIR + File.separator + file);
            if (fileLength != body.length)
                throw new IOException("Invalid length in HTTP:" + file);
            if (buffer.length != fileLength)
                throw new IOException("Invalid file length:" + file);
            for (int i = 0; i < buffer.length; i++)
                if (buffer[i] != body[i])
                    throw new IOException("Invalid file:" + file);
        } catch (IOException e) {
            isread = false;
            log.log(Level.INFO, " ClientVerify: " + e.toString());
            //log.log(Level.INFO, "Client:" + e.toString());
        }
    if (isread) {
        final String outPath = outfile + new File(file).getName();
        final FileOutputStream fos = new FileOutputStream(outPath);
        fos.write(buffer);
        fos.close();
        log.log(Level.INFO, "answer was writing to: " + outPath);
    } else {
        final String outPath = outfile + ".html";
        final FileOutputStream fos = new FileOutputStream(outPath);
        String s = "<p align=\"left\">" +
                "<font color=\"#FF9909\" size=\"5\" face=\"Times New Roman\">" +
                "<u>ANSWER:</u>" +
                "</font></p>";
        fos.write(s.getBytes());
        fos.write(answer.getBytes());
        s = "<p align=\"left\">" +
                "<font color=\"#FF9909\" size=\"5\" face=\"Times New Roman\">" +
                "<u>PAGE:</u>" +
                "</font></p>";
        fos.write(s.getBytes());
        fos.write(buffer);
        fos.close();
        log.log(Level.INFO, "answer was writing to: " + outPath);
    }
}

/**
 *     .    new byte[] {(byte)' '}
 *
 * @param in  
 * @param end  
 * @return  ( )
 * @throws IOException  -
 */
public static byte[] readHeader(InputStream in, byte[] end) throws IOException {
    final ByteArrayOutputStream baos = new ByteArrayOutputStream();
    int conformity = 0;
    int next;
    log.log(Level.FINE, " Try reading (Client.readHeader)");
    do {
        next = in.read();
        if (next == -1)
            throw new IOException(" Client: Error reading HTTP header");
        baos.write(next);
        if (next == end[conformity])
            conformity++;
        else
            conformity = 0;
    } while (conformity != end.length);
    return baos.toByteArray();
}

/**
 *    .
 *
 * @param in InputStream
 * @param len length
 * @return 
 * @throws IOException  -
 */
public static byte[] readBody(InputStream in, int len) throws IOException {
    final byte[] buf = new byte[len];
    int next;
    int pos = 0;
    while (pos != len) {
        next = in.read();
        if (next == -1)
            throw new IOException(" Error reading HTTP body");
        buf[pos++] = (byte) next;
    }
//    while (true) {
//        next = in.read();
//        if (next == -1)
//            break;
//        buf[pos++] = (byte) next;
//    }
//    if (pos < len)
//        throw new IOException("Error reading HTTP body");
    return buf;
}

/**
 *  
 *
 * @param name 
 * @return 
 * @throws IOException  -
 */
public static byte[] readFile(String name) throws IOException {
    byte[] buffer;
    FileInputStream is = null;
    try {
        final File file = new File(name);
        is = new FileInputStream(file);
        buffer = new byte[(int) file.length()];

        int len;
        int total = 0;
        do {
            len = is.read(buffer, total, buffer.length - total);
            if (len == -1)
                throw new IOException(" Client: Error reading file:" + name);
            total += len;
        } while (total != buffer.length);
    } finally {
        if (is != null) is.close();
    }
    return buffer;
}

/**
 *       
 *
 * @param str  
 * @return  
 * @throws IOException  -
 */
public static int parseAnswer(String str) throws IOException {
    final String[] split = str.split("\r\n");
    if (!split[0].equals("HTTP/1.0 200 OK") &&
            !split[0].equals("HTTP/1.1 200 OK"))
        throw new IOException(split[0]);
    //throw new IOException("Unknown answer");
    int len = -1;
    for (int i = 1; i < split.length; i++)
        if (split[i].startsWith("Content-Length:")) {
            final String ss =
                    split[i].substring("Content-Length:".length()).trim();
            len = Integer.parseInt(ss);
            break;
        }
    return len;
}
}
