/**
 * $RCSfile: servkey.java,v $
 * version $Revision: 1.5 $
 * created 05.07.2007 10:24:37 by kunina
 * last modified $Date: 2008/10/29 11:34:12 $ by $Author: kunina $
 * (C)  - 2004-2007.
 *
 *  ,    , 
 *   .      
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package JTLS_samples;

import ru.CryptoPro.JCP.tools.JCPLogger;
import ru.CryptoPro.JCPRequest.GostCertificateRequest;

import java.io.ByteArrayInputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.KeyStore;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.cert.Certificate;
import java.security.cert.CertificateFactory;

/**
 *  ().
 *
 * @author Copyright 2004-2007 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class servkey {
/**
 *
 */
private servkey() {
}

public static void main(String[] args) throws Exception {
    final KeyPairGenerator kg = KeyPairGenerator.getInstance("GOST3410DH");
    final KeyPair pair = kg.generateKeyPair();
    //   
    final PrivateKey privKey = pair.getPrivate();
    //    
    final PublicKey pubKey = pair.getPublic();

    final String keyAlg = "GOST3410DH";
    final boolean isServer = true;
    final String httpAddress = "http://www.cryptopro.ru/certsrv/";
    final String certName = "CN=serv, O=CryptoPro, C=RU";
    final String keystorePass = "null";
    final String keystorePath = "null";
    final String keypass = "pass";
    final String alias = "serKey";
    final String keystoreName = "HDImageStore";

    //      
    final GostCertificateRequest req = new GostCertificateRequest();
    req.init(keyAlg, isServer);
    req.setPublicKeyInfo(pubKey);
    //  
    req.setSubjectInfo(certName);
    req.encodeAndSign(privKey);

    //        
    //   DER-
    byte[] encoded = req.getEncodedCert(httpAddress);

    //  X509-    
    CertificateFactory cf = CertificateFactory.getInstance("X509");
    Certificate cert =
            cf.generateCertificate(new ByteArrayInputStream(encoded));

    //        
    final Certificate certRoot = cf.generateCertificate(
            new ByteArrayInputStream(
                    GostCertificateRequest.getEncodedRootCert(httpAddress)));

    final Certificate[] certs = new Certificate[1];
    certs[0] = cert;

    final KeyStore ks = KeyStore.getInstance(keystoreName);
    char[] KeyStorePass = null;
    if (!"null".equalsIgnoreCase(keystorePass)) {
        KeyStorePass = keystorePass.toCharArray();
    }
    InputStream is = null;
    if (!"null".equalsIgnoreCase(keystorePath)) {
        is = new FileInputStream(keystorePath);
    }
    ks.load(is, KeyStorePass);/**/
    char[] Keypass = null;
    if (!"null".equalsIgnoreCase(keypass)) {
        Keypass = keypass.toCharArray();
    }
    ks.setKeyEntry(alias, privKey, Keypass, certs);
    ks.setCertificateEntry("CPTrootCert", certRoot);
    OutputStream os = null;
    if (!"null".equalsIgnoreCase(keystorePath)) {
        os = new FileOutputStream(keystorePath);
    }
    ks.store(os, KeyStorePass);
    JCPLogger.trace("Recording of a private key named \"" + alias + "\" to " +
            keystoreName + " is completed.");

}
}
