/**
 * $RCSfile: CertFingerPrint.java,v $
 * version $Revision: 1.2 $
 * created 07.07.2008 15:20:54 by kunina
 * last modified $Date: 2009/05/26 13:41:33 $ by $Author: kunina $
 * (C)  - 2004-2008.
 *
 *  ,    , 
 *   .      
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package userSamples;

import ru.CryptoPro.JCPRequest.GostCertificateRequest;

import java.io.ByteArrayInputStream;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.security.cert.Certificate;
import java.security.cert.CertificateEncodingException;
import java.security.cert.CertificateFactory;

/**
 *  .
 *
 * @author Copyright 2004-2008 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class CertFingerPrint {
 /**/
private CertFingerPrint() {
}

/**
 *     (  )
 *
 * @param args /
 * @throws Exception /
 */
public static void main(String[] args) throws Exception {
    //   
    final KeyPairGenerator kg =
            KeyPairGenerator.getInstance(Constants.SIGN_KEY_PAIR_ALG);
    final GostCertificateRequest gr = new GostCertificateRequest();
    final CertificateFactory cf =
            CertificateFactory.getInstance(Constants.CF_ALG);
    final KeyPair kp = kg.generateKeyPair();
    final String name = "CN=cert";
    final byte[] enc = gr.getEncodedSelfCert(kp, name);
    final Certificate cert =
            cf.generateCertificate(new ByteArrayInputStream(enc));
    //  
    final String fp = fingerPrintCert(cert, "SHA1");
    System.out.println(fp);
}

/**
 *   
 *
 * @param cert 
 * @param alg  (SHA1)
 * @return hex-string
 * @throws CertificateEncodingException /
 * @throws NoSuchAlgorithmException /
 */
private static String fingerPrintCert(Certificate cert, String alg)
        throws CertificateEncodingException, NoSuchAlgorithmException {
    final byte[] encCertInfo = cert.getEncoded();
    final MessageDigest md = MessageDigest.getInstance(alg);
    final byte[] digest = md.digest(encCertInfo);
    return Constants.toHexString(digest);
}
}
