/**
 * $RCSfile: CheckImita.java,v $
 * version $Revision: 1.8 $
 * created 27.09.2005 20:51:25 by elvira
 * last modified $Date: 2009/05/27 12:31:24 $ by $Author: kunina $
 * (C)  - 2004-2009.
 *
 *  ,    , 
 *   .     
 *         .
 *
 *       
 *   .  -   
 *     .
 */

package userSamples;

import javax.crypto.KeyAgreement;
import javax.crypto.Mac;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import java.security.KeyPair;
import java.security.SecureRandom;
import java.security.cert.Certificate;

/**
 *        
 *    28147-89    .
 */
public class CheckImita {
/**
 * 
 */
private static final String SAMPLE_TEXT = "Example text";
/**
 *  
 */
private static final int RND_LENGTH = 8;


/**
 * @param args null
 * @throws Exception /
 */
public static void main(String[] args) throws Exception {
    final byte[] data = SAMPLE_TEXT.getBytes();
    /**    :
     * -   
     * -     ()**/

    /*     */
    final KeyPair alisaPair = KeyPairGen.genKey(Constants.EXCH_KEY_PAIR_ALG);
    final KeyPair bobPair = KeyPairGen.genKey(Constants.EXCH_KEY_PAIR_ALG);

    /*     */
    final Certificate alisaCert = KeyPairGen
            .genSelfCert(alisaPair, "CN=ALISA_CERTIFICATE, O=CryptoPro, C=RU");
    final Certificate bobCert = KeyPairGen
            .genSelfCert(bobPair, "CN=BOB_CERTIFICATE, O=CryptoPro, C=RU");

    /*       */
    final byte[] sv = new byte[RND_LENGTH];
    final SecureRandom random = SecureRandom.getInstance(Constants.RANDOM_ALG);
    random.nextBytes(sv);
    final IvParameterSpec ivspec = new IvParameterSpec(sv);

    /*     c SV*/
    final KeyAgreement alisaKeyAgree =
            KeyAgreement.getInstance(Constants.EXCH_KEY_PAIR_ALG);
    alisaKeyAgree.init(alisaPair.getPrivate(), ivspec, null);
    alisaKeyAgree.doPhase(bobCert.getPublicKey(), true);
    final SecretKey alisaAgree =
            alisaKeyAgree.generateSecret(Constants.CHIPHER_ALG);

    /*       */
    Mac mac = Mac.getInstance(Constants.CHIPHER_ALG);
    mac.init(alisaAgree);
    mac.update(data);
    final byte[] alisaImita = mac.doFinal();

    /*        SV. */
    final KeyAgreement bobKeyAgree =
            KeyAgreement.getInstance(Constants.EXCH_KEY_PAIR_ALG);
    bobKeyAgree.init(bobPair.getPrivate(), ivspec, null);
    bobKeyAgree.doPhase(alisaCert.getPublicKey(), true);
    final SecretKey bobAgree = bobKeyAgree.generateSecret(Constants.CHIPHER_ALG);

    /*       */
    mac = Mac.getInstance(Constants.CHIPHER_ALG);
    mac.init(bobAgree);
    mac.update(data);
    final byte[] bobImita = mac.doFinal();

    //  .
    if (alisaImita.length != bobImita.length)
        throw new Exception("Error in computing imita");

    for (int i = 0; i < alisaImita.length; i++)
        if (alisaImita[i] != bobImita[i])
            throw new Exception("Error in computing imita");

    System.out.println("OK");
}
}
