/**
 * $RCSfile: ClassicEncrypt.java,v $
 * version $Revision: 1.12 $
 * created 23.09.2005 20:05:23 by elvira
 * last modified $Date: 2009/05/27 12:56:18 $ by $Author: kunina $
 * (C)  - 2004-2005.
 *
 *  ,    , 
 *   .     
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package userSamples;

import javax.crypto.Cipher;
import javax.crypto.KeyAgreement;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import java.security.KeyPair;
import java.security.SecureRandom;
import java.security.cert.Certificate;

/**
 *         
 *   (   ).
 */
public class ClassicEncrypt {
/**
 * 
 */
private static final String SAMPLE_TEXT = "Classic encryption/decryption";
/**
 *  
 */
private static final int RND_LENGTH = 8;
/**
 *  
 */
private static final String CIPHER_ALG = "GOST28147/CFB/NoPadding";

/**
 * @param args null
 * @throws Exception /
 */
public static void main(String[] args) throws Exception {
    final byte[] data = SAMPLE_TEXT.getBytes();
    /**    :
     * -   
     * -     ()**/

    /*     */
    final KeyPair alisaPair = KeyPairGen.genKey(Constants.EXCH_KEY_PAIR_ALG);
    final KeyPair bobPair = KeyPairGen.genKey(Constants.EXCH_KEY_PAIR_ALG);

    /*     */
    final Certificate alisaCert = KeyPairGen
            .genSelfCert(alisaPair, "CN=ALISA_CERTIFICATE, O=CryptoPro, C=RU");
    final Certificate bobCert = KeyPairGen
            .genSelfCert(bobPair, "CN=BOB_CERTIFICATE, O=CryptoPro, C=RU");

    /*       */
    final byte[] sv = new byte[RND_LENGTH];
    final SecureRandom random = SecureRandom.getInstance(Constants.RANDOM_ALG);
    random.nextBytes(sv);
    final IvParameterSpec ivspec = new IvParameterSpec(sv);

    /*     c SV*/
    final KeyAgreement alisaKeyAgree =
            KeyAgreement.getInstance(Constants.EXCH_KEY_PAIR_ALG);
    alisaKeyAgree.init(alisaPair.getPrivate(), ivspec, null);
    alisaKeyAgree.doPhase(bobCert.getPublicKey(), true);
    final SecretKey alisaAgree =
            alisaKeyAgree.generateSecret(Constants.CHIPHER_ALG);

    /*     */
    Cipher cipher = Cipher.getInstance(CIPHER_ALG);
    cipher.init(Cipher.ENCRYPT_MODE, alisaAgree);
    //    
    final byte[] iv = cipher.getIV();
    final byte[] encryptedtext = cipher.doFinal(data, 0, data.length);

    /*        SV. */
    final KeyAgreement bobKeyAgree =
            KeyAgreement.getInstance(Constants.EXCH_KEY_PAIR_ALG);
    bobKeyAgree.init(bobPair.getPrivate(), ivspec, null);
    bobKeyAgree.doPhase(alisaCert.getPublicKey(), true);
    final SecretKey bobAgree =
            bobKeyAgree.generateSecret(Constants.CHIPHER_ALG);

    /*     . IV   */
    cipher = Cipher.getInstance(CIPHER_ALG);
    cipher.init(Cipher.DECRYPT_MODE, bobAgree, new IvParameterSpec(iv), null);
    final byte[] decryptedtext = cipher
            .doFinal(encryptedtext, 0, encryptedtext.length);

    //  .
    if (decryptedtext.length != data.length)
        throw new Exception("Error in crypting");
    for (int i = 0; i < decryptedtext.length; i++)
        if (data[i] != decryptedtext[i])
            throw new Exception("Error in crypting");

    System.out.println("OK");
}
//      
//final PublicKey pubKey;
//final KeyFactory keyFactory = KeyFactory.getInstance(pubKey.getAlgorithm());
//final X509EncodedKeySpec pubKeySpec = new X509EncodedKeySpec(pubKey.getEncoded());
//final PublicKey publicKey = keyFactory.generatePublic(pubKeySpec);
}
