/**
 * $RCSfile: CloneImita.java,v $
 * version $Revision: 1.5 $
 * created 27.09.2005 20:17:49 by elvira
 * last modified $Date: 2009/05/27 13:09:17 $ by $Author: kunina $
 * (C)  - 2004-2009.
 *
 *  ,    , 
 *   .     
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package userSamples;

import javax.crypto.KeyGenerator;
import javax.crypto.Mac;
import javax.crypto.SecretKey;

/**
 *        
 *    28147-89     
 * :     ,   
 *    .
 */
public class CloneImita {
/**
 * 
 */
private static final String SAMPLE_TEXT = "computing imita with cloning";

/**
 * @param args null
 * @throws Exception /
 */
public static void main(String[] args) throws Exception {
    final byte[] data = SAMPLE_TEXT.getBytes();
    /*      
       .*/
    final KeyGenerator keyGen = KeyGenerator.getInstance(Constants.CHIPHER_ALG);
    final SecretKey simm = keyGen.generateKey();

    /*       */
    final Mac mac = Mac.getInstance(Constants.CHIPHER_ALG);
    mac.init(simm);
    mac.update(data);
    final byte[] imitaAll = mac.doFinal();

    /*          */
    final byte[] first = new byte[data.length / 2];
    final byte[] second = new byte[data.length - data.length / 2];
    System.arraycopy(data, 0, first, 0, first.length);
    System.arraycopy(data, first.length, second, 0, second.length);

    //  
    mac.reset();
    mac.update(first);

    //
    final Mac dupMac = (Mac) mac.clone();

    //     
    mac.update(second);
    final byte[] imitaFirst = mac.doFinal();

    //     
    dupMac.update(second);
    final byte[] imitaSecond = dupMac.doFinal();

    //  .
    if (imitaAll.length != imitaFirst.length ||
            imitaAll.length != imitaSecond.length)
        throw new Exception("Error in computing imita");

    for (int i = 0; i < imitaAll.length; i++)
        if (imitaAll[i] != imitaFirst[i] || imitaAll[i] != imitaSecond[i])
            throw new Exception("Error in computing imita");

    System.out.println("OK");
}
}
