/**
 * $RCSfile: Digest.java,v $
 * version $Revision: 1.9 $
 * created 14.04.2005 17:49:03 by elvira
 * last modified $Date: 2009/06/10 09:08:38 $ by $Author: kunina $
 * (C)  - 2004-2005.
 *
 *  ,    , 
 *   .     
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package userSamples;

import ru.CryptoPro.JCP.Digest.GostDigest;
import ru.CryptoPro.JCP.params.OID;

import java.io.ByteArrayInputStream;
import java.security.DigestInputStream;
import java.security.MessageDigest;

/**
 *          
 *    34.11-94.
 */
public class Digest {
/**
 * 
 */
private static final String SAMPLE_TEXT = "message digest example";

/**
 * @param args null
 * @throws Exception /
 */
public static void main(String[] args) throws Exception {
    System.out.println("DigestInputStream: ");
    System.out.println(Constants.toHexString(computeDigestWithStream()));
    System.out.println("MessageDigest: ");
    System.out.println(Constants.toHexString(computeDigestWithoutStream()));
    System.out.println("CloneDigest with params: ");
    computeDigestWithClone();
    System.out.println("OK");
}

/**
 *      DigestInputStream
 *
 * @return  
 * @throws Exception /
 */
public static byte[] computeDigestWithStream() throws Exception {
    //    
    final MessageDigest digest =
            MessageDigest.getInstance(Constants.DIGEST_ALG);

    //   
    final ByteArrayInputStream stream =
            new ByteArrayInputStream(SAMPLE_TEXT.getBytes());
    final DigestInputStream digestStream =
            new DigestInputStream(stream, digest);
    while (digestStream.available() != 0)
        digestStream.read();

    //   
    return digest.digest();
}

/**
 *       MessageDigest
 *
 * @return  
 * @throws Exception /
 */
public static byte[] computeDigestWithoutStream() throws Exception {
    //    
    final MessageDigest digest =
            MessageDigest.getInstance(Constants.DIGEST_ALG);

    //   
    final byte[] data = SAMPLE_TEXT.getBytes();
    digest.update(data);

    //   
    return digest.digest();
}

/**
 *         
 *   
 *
 * @throws Exception /
 */
public static void computeDigestWithClone() throws Exception {
    // !      
    //      :
    // "1.2.643.2.2.30.1"

    final OID digestOID = new OID("1.2.643.2.2.30.2");
    //    
    final MessageDigest digest = MessageDigest.getInstance(Constants.DIGEST_ALG);

    //   
    final GostDigest gostDigest = (GostDigest) digest;
    gostDigest.reset(digestOID);

    final byte[] data = SAMPLE_TEXT.getBytes();
    //  
    final byte[] firstBloc = new byte[data.length / 2];
    //  
    final byte[] secondBloc = new byte[data.length - firstBloc.length];

    //     
    gostDigest.update(firstBloc);

    //  ()    
    //  
    final MessageDigest firstDigest = (MessageDigest) gostDigest.clone();

    //     
    gostDigest.update(secondBloc);

    //      
    final byte[] resultFirst = firstDigest.digest();
    System.out.println(Constants.toHexString(resultFirst));

    //      
    final byte[] resultAll = gostDigest.digest();
    System.out.println(Constants.toHexString(resultAll));
}
}
