/**
 * $RCSfile: ExampleExtKUProcessor.java,v $
 * version $Revision: 1.4 $
 * created 19.07.2006 19:20:54 by borodin
 * last modified $Date: 2008/10/29 11:36:08 $ by $Author: kunina $
 * (C)  - 2004-2006.
 *
 *  ,    , 
 *   .     
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package userSamples;

import ru.CryptoPro.JCP.params.OIDName;
import ru.CryptoPro.JCP.tools.CertReader.Extension;
import ru.CryptoPro.JCP.tools.CertReader.ExtensionProcessor;

import java.security.cert.CertificateParsingException;
import java.security.cert.X509Certificate;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

/**
 *    "  ".
 *    Extension  ExtensionProcessor.
 * <p/>
 * <p/>
 *     ,    
 * ,     .  "
 *  "      .
 */
public class ExampleExtKUProcessor extends ExtensionProcessor {

/**
 *   "  ".
 */
private static final String OID_EXT_KEY_USAGE = "2.5.29.37";

/**
 * public - , ,      
 * .
 */
public ExampleExtKUProcessor() {
}

/**
 *  
 *
 * @return  OID
 */
public String getOID() {
    return OID_EXT_KEY_USAGE;
}

/**
 *      
 *
 * @param oid ID  
 * @return ,   - OID', 
 *          - OID',   , ,   OID ,
 *           - OID  .
 */
static Extension getOneUsage(String oid) {
    Extension ret;
    /**
     *  
     */
    String name = OIDName.getName(oid);
    /**
     *  Extension - OID  
     */
    Extension down = new Extension(Extension.O_BRAKE_SPACE.concat(oid)
            .concat(Extension.C_BRAKE));
    /**
     *       ,
     */
    if (name.equals(oid)) {
        /**
         *   OID,
         */
        ret = down;
    } else {
        /**
         *   ,   - OID',
         *  - OID'a  .     , 
         *   .
         */
        ret = new Extension(name, down, Extension.STANDARD_WITH_TITLE);
    }
    return ret;
}

/**
 *      
 *
 * @param cert ,   
 * @return   
 */
public Extension getExtension(X509Certificate cert) {
    /**
     *   
     */
    Vector strings = new Vector(0);
    try {
        /**
         *     .
         */
        List usg = cert.getExtendedKeyUsage();
        /**
         *    ,     
         */
        if (usg != null) {
            for (Iterator iter = usg.iterator(); iter.hasNext();) {
                strings.add(iter.next().toString());
            }
        } else {
            /**
             *       
             */
            strings.add(new Extension(getErrorParamMessage()));
        }
    } catch (CertificateParsingException e) {
        /**
         *      .
         */
        strings.add(new Extension(getErrorParamMessage()));
    }
    /**
     *  ,   getName()   -
     * strings. getName()    ,  JCP  OID
     * .
     */
    return new Extension(getName(), strings);
}

/**
 *       
 *
 * @param args  
 */
public static void main(String[] args) {
    new ExampleExtKUProcessor().registerNewProcessor();
}
}
