/**
 * $RCSfile: SessionEncrypt.java,v $
 * version $Revision: 1.8 $
 * created 26.09.2005 14:44:17 by elvira
 * last modified $Date: 2009/05/27 13:04:56 $ by $Author: kunina $
 * (C)  - 2004-2009.
 *
 *  ,    , 
 *   .     
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package userSamples;

import javax.crypto.Cipher;
import javax.crypto.KeyAgreement;
import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import java.security.KeyPair;
import java.security.SecureRandom;
import java.security.cert.Certificate;

/**
 *         
 *  .        
 *     .
 */
public class SessionEncrypt {
/**
 * 
 */
private static final String SAMPLE_TEXT = "Classic encryption/decryption";
/**
 *  
 */
private static final int RND_LENGTH = 8;
/**
 *  
 */
private static final String CIPHER_ALG = "GOST28147/CFB/NoPadding";

public static final int randomLength = 8;

public static void main(String[] args) throws Exception {
    final byte[] data = SAMPLE_TEXT.getBytes();
    /**    :
     * -   
     * -     ()**/

    /*     */
    final KeyPair alisaPair = KeyPairGen.genKey(Constants.EXCH_KEY_PAIR_ALG);
    final KeyPair bobPair = KeyPairGen.genKey(Constants.EXCH_KEY_PAIR_ALG);

    /*     */
    final Certificate alisaCert = KeyPairGen
            .genSelfCert(alisaPair, "CN=ALISA_CERTIFICATE, O=CryptoPro, C=RU");
    final Certificate bobCert = KeyPairGen
            .genSelfCert(bobPair, "CN=BOB_CERTIFICATE, O=CryptoPro, C=RU");

    /*       */
    final byte[] sv = new byte[RND_LENGTH];
    final SecureRandom random = SecureRandom.getInstance(Constants.RANDOM_ALG);
    random.nextBytes(sv);
    final IvParameterSpec ivspec = new IvParameterSpec(sv);

    /*     c SV*/
    final KeyAgreement alisaKeyAgree =
            KeyAgreement.getInstance(Constants.EXCH_KEY_PAIR_ALG);
    alisaKeyAgree.init(alisaPair.getPrivate(), ivspec, null);
    alisaKeyAgree.doPhase(bobCert.getPublicKey(), true);
    final SecretKey alisaAgree =
            alisaKeyAgree.generateSecret(Constants.CHIPHER_ALG);

    /*          */
    final KeyGenerator keyGen = KeyGenerator.getInstance(Constants.CHIPHER_ALG);
    final SecretKey simm = keyGen.generateKey();

    /*      */
    Cipher cipher = Cipher.getInstance(CIPHER_ALG);
    cipher.init(Cipher.ENCRYPT_MODE, simm);
    //    
    final byte[] iv = cipher.getIV();
    final byte[] encryptedtext = cipher.doFinal(data, 0, data.length);

    /*      */
    cipher.init(Cipher.WRAP_MODE, alisaAgree);
    final byte[] wrappedKey = cipher.wrap(simm);

    /*        SV. */
    final KeyAgreement bobKeyAgree =
            KeyAgreement.getInstance(Constants.EXCH_KEY_PAIR_ALG);
    bobKeyAgree.init(bobPair.getPrivate(), ivspec, null);
    bobKeyAgree.doPhase(alisaCert.getPublicKey(), true);
    final SecretKey bobAgree =
            bobKeyAgree.generateSecret(Constants.CHIPHER_ALG);

    /*    .*/
    cipher.init(Cipher.UNWRAP_MODE, bobAgree);
    final SecretKey simmKey = (SecretKey) cipher
            .unwrap(wrappedKey, null, Cipher.SECRET_KEY);

    /*       . IV   */
    cipher = Cipher.getInstance(CIPHER_ALG);
    cipher.init(Cipher.DECRYPT_MODE, simmKey, new IvParameterSpec(iv), null);
    final byte[] decryptedtext = cipher
            .doFinal(encryptedtext, 0, encryptedtext.length);

    //  .
    if (decryptedtext.length != data.length)
        throw new Exception("Error in crypting");
    for (int i = 0; i < decryptedtext.length; i++)
        if (data[i] != decryptedtext[i])
            throw new Exception("Error in crypting");

    System.out.println("OK");
}
}
