/**
 * $RCSfile: XmlDSigTest.java,v $
 * version $Revision: 1.6 $
 * created 30.12.2004 15:28:45 by avsh
 * last modified $Date: 2008/10/29 11:36:08 $ by $Author: kunina $
 * (C)  - 2004-2005.
 *
 *  ,    , 
 *   .     
 *         .
 *
 *       
 *   .  -   
 *     .
 */
package userSamples;

import org.w3c.dom.Document;
import ru.CryptoPro.JCPRequest.GostCertificateRequest;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import java.io.ByteArrayInputStream;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.security.KeyPairGenerator;
import java.security.PrivateKey;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;

/**
 *       XML- 
 *      34.10-2001.
 */
public class XmlDSigTest {
public static void main(String[] args) throws Exception {
    System.out.println("Example of signing XML document:");
    String KeyPairAlgorithm = "GOST3410";
    //   
    KeyPairGenerator keyGen = KeyPairGenerator.getInstance(KeyPairAlgorithm);
    java.security.KeyPair pair = keyGen.generateKeyPair();
    PrivateKey privKey = pair.getPrivate();
    System.out.println("Key pair is generated");
    //  
    GostCertificateRequest gr = new GostCertificateRequest();
    byte[] enc = gr.getEncodedSelfCert(pair, "CN=newCert, O=CryptoPro, C=RU");
    CertificateFactory cf = CertificateFactory.getInstance("X509");
    X509Certificate cert = (X509Certificate) cf
            .generateCertificate(new ByteArrayInputStream(enc));

    System.out.println("Certificate is generated");
    //  XML 
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    dbf.setNamespaceAware(true);
    Document doc = dbf.newDocumentBuilder().newDocument();
    //   XML 
    XWSXmlDSig xmldsig = new XWSXmlDSig();
    //    
    xmldsig.setPrivateKey(privKey);
    //    
    xmldsig.SetCertificate(cert);
    xmldsig.setSignMethod(
            "http://www.w3.org/2001/04/xmldsig-more#gostr34102001-gostr3411");
    xmldsig.setdigestMethod("http://www.w3.org/2001/04/xmldsig-more#gostr3411");

    //  
    doc = xmldsig.SignObject();
    //    
    OutputStream os;
    os = new FileOutputStream("XmlDSigObject.xml");

    TransformerFactory tf = TransformerFactory.newInstance();
    Transformer trans = tf.newTransformer();
    trans.transform(new DOMSource(doc), new StreamResult(os));
    os.close();

    //        
    doc = dbf.newDocumentBuilder().parse("XmlDSigObject.xml");
    boolean res = XWSXmlDSig.Validate(doc);
    if (res) {
        System.out.println(
                "Test for sign and verify object of XML document is passed");
        System.out.println();
    }
}
}



